--	SMH - Simply Magical Healer
--	Written by scott@mithrandir.com
--	Official website:  http://www.mithrandir.com/WorldOfWarcraft/WoW.html
--
--	TODO:
--		* Think about making use of Swiftmend
--		* Think about making smart use of Binding Heal
--		* Think about making smart use of Lifebloom (limit of 3 effects on recipient)
--		* Need to make the channel message not sent in instant casts (like Nature's Swiftness)
--		* Make it so tree form cannot cast Healing Touch

SMH_File_Version = 09940

if nil == SMH.addonMainVersionNumber or SMH.addonMainVersionNumber < SMH_File_Version then

	SMH.addonMacroCommand = "/smh"
	SMH.addonMainVersionNumber = SMH_File_Version
	SMH.cachedSpellTargetLevels = {
		[SMH_S.HEALING_TOUCH] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_S.LIFEBLOOM] = { 64 },
		[SMH_S.REGROWTH] = { 12, 18, 24, 30, 36, 42, 48, 54, 60, 66 },
		[SMH_S.REJUVENATION] = { 4, 10, 16, 22, 28, 34, 40, 46, 52, 58, 60, 64, 70 },
		[SMH_S.HOLY_LIGHT] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_S.FLASH_OF_LIGHT] = { 1, 1, 1, 1, 1, 1, 1 },
		[SMH_S.BINDING_HEAL] = { 1 },
		[SMH_S.LESSER_HEAL] = { 1, 1, 1 },
		[SMH_S.FAKE_COMBINED_HEAL] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_S.RENEW] = { 8, 14, 20, 26, 32, 38, 44, 50, 56, 60, 65, 70 },
		[SMH_S.FLASH_HEAL] = { 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_S.CHAIN_HEAL] = { 1, 1, 1, 1, 1 },
		[SMH_S.HEALING_WAVE] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_S.LESSER_HEALING_WAVE] = { 1, 1, 1, 1, 1, 1, 1 },
		}
	SMH.commandFunctions = {
		[SMH_S.COMMAND_ABOUT] = function() SMH:About() end,
		[SMH_S.COMMAND_HELP] = function() SMH:Help() end ,
		[SMH_S.COMMAND_TEST] = function() SMH:Test() end,
		[SMH_S.COMMAND_UI] = function() SMH:Options_ShowHide() end,
		}
	SMH.currentGroupStatus = {}
	SMH.eventMainDispatch = {			-- table of functions whose keys are the events
		['PLAYER_ENTERING_WORLD'] = function(self)
			--	Now we set up the OnUpdate handling which we use to attempt to detect movement
			--	and we clear it in case we are in an instance, thereby attempting to make this
			--	addon really quick in an instance, because detecting movement does not work in
			--	an instance.
			if IsInInstance() then
				this:SetScript("OnUpdate", nil)
				self.isMoving = false
			else
				this:SetScript("OnUpdate", function() self:MainFrame_OnUpdate() end)
			end
		end,
		['PLAYER_FOCUS_CHANGED'] = function(self)
			self:ChangeOfFocus()
		end,
		['PLAYER_REGEN_ENABLED'] = function(self)
			if pendingSpellUpdate then
				pendingSpellUpdate = false
				self:UpdateSpells()
			end
		end,
		['PLAYER_TARGET_CHANGED'] = function(self)
			self:ChangeOfTarget()
		end,
		['UNIT_SPELLCAST_FAILED'] = function(self, unit)
			if unit == 'player' and self.initiatedCast then
				self:OutputChannelMessageStop("SMH", "FAIL")
				self.initiatedCast = false
			end
		end,
		['UNIT_SPELLCAST_INTERRUPTED'] = function(self, unit)
			if unit == 'player' and self.initiatedCast then
				self:OutputChannelMessageStop("SMH", "INTERRUPT")
				self.initiatedCast = false
			end
		end,
		['UNIT_SPELLCAST_SENT'] = function(self, player, spellName, rankName, targetName)
			self:ClearLitButton()
			if nil ~= self.defaultCastTimes[spellName] then
				local rank = self:PIFirst(rankName)
				local targetId = nil
				if UnitName('target') == targetName then
					targetId = 'target'
				elseif UnitName('focus') == targetName then
					targetId = 'focus'
				elseif UnitName('player') == targetName then
					targetId = 'player'
				end
				local healingAmount = self:EstimatedHealing(nil, spellName, rank, targetId)
				self:OutputMessage("CAST", string.format(SMH_S.INFORMATIVE_MESSAGE_HEALINGFORMAT, spellName, rank, targetName))
				self:OutputChannelMessage("SMH", spellName, rank, targetName, healingAmount)
				self.initiatedCast = true
			end
		end,
		['UNIT_SPELLCAST_SUCCEEDED'] = function(self, player, spell, rank)
			if self.initiatedCast then
				self:OutputChannelMessageStop("SMH", "SUCCESS")
				self.initiatedCast = false
			end
		end,
		['VARIABLES_LOADED'] = function(self)
			-- create the contents of the frame that will hold the spell cast buttons
			local frame = com_mithrandir_smhMainFrame
			frame:SetWidth(300)
			frame:SetHeight(150)
			local region = frame:CreateTitleRegion()
			region:SetAllPoints(frame)
			frame:SetBackdrop({ bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, edgeSize = 32, tileSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 } })
			frame:SetPoint("CENTER", "UIParent")
			self.currentFocusText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
			self.currentFocusText:SetPoint("TOPLEFT", frame, "TOPLEFT", 15, -15)
			self.currentTargetText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
			self.currentTargetText:SetPoint("TOPLEFT", self.currentFocusText, "TOPLEFT", 0, -20)
			self:ChangeOfFocus()
			self:ChangeOfTarget()
			self:RegisterForNotification(SMH_E.NOTIFICATION_CACHED_SPELLBOOK, function() if InCombatLockdown() then pendingSpellUpdate = true else self:UpdateSpells() end end)
			-- register with Grid
			self.grid = GridStatus
			self.grid:RegisterStatus("com_mithrandir_smhSelect", "SMH", nil, false)
		end,
		}
	SMH.initiatedCast = false			-- used to indicate one of the spells in which we have interest is being cast
	SMH.isMoving = false				-- determined using below two variables
	SMH.lastX = 0					-- where we last were in X
	SMH.lastY = 0					-- where we last were in Y
	SMH.pendingSpellUpdate = false
	SMH.shapeshiftBuffs = { [SMH_S.DIRE_BEAR_FORM] = true, [SMH_S.BEAR_FORM] = true, [SMH_S.CAT_FORM] = true, [SMH_S.AQUATIC_FORM] = true, [SMH_S.MOONKIN_FORM] = true, [SMH_S.TRAVEL_FORM] = true, }
	SMH.spellButtons = { }				-- spell buttons stored here instead of cachedSpellbookData because that data structure is wiped when rereading spellbook
	SMH.spellButtonBacks = { }

	SMH.About = function(self)
		self:OutputMessage("INFO", "|cFFFF0000S|rimply |cFFFF0000M|ragical |cFFFF0000H|realer");
		self:OutputMessage("INFO", "  Version: " .. self.addonMainVersionNumber)
		self:OutputMessage("INFO", "  Options Version: " .. self.addonOptionsVersionNumber)
		self:OutputMessage("INFO", "  Backend Version: " .. self.addonVersionNumber)
		self:OutputMessage("INFO", "  Author: scott@mithrandir.com")
		self:OutputMessage("INFO", "  Website: http://www.mithrandir.com/WorldOfWarcraft/WoW.html")
	end

	SMH.CannotCast = function(self, reason)
		self:OutputMessage("ERROR", self.colorRed .. SMH_S.CANNOT_CAST .. reason .. self.colorStop)
	end

	--	returns the name of the buff that is problematic
	SMH.CastStoppingBuff = function(self, buffs)
		local retval = nil
		local playerBuffs = buffs or self:UnitBuffs('player')
		for n in pairs(playerBuffs) do if playerBuffs[n]["castStopping"] then retval = n; break end end
		return retval
	end

	SMH.ChangeOfFocus = function(self)
		local focusName = UnitName('focus') or ''
		self.currentFocusText:SetText(self.colorBlue .. SMH_S.SPELLUI_FOCUS_TEXT .. self.colorStop .. focusName)
		if nil ~= self.litUnit and UnitIsUnit(self.litUnit, 'focus') then
			self.grid:SendStatusLost(UnitName(self.litUnit), "com_mithrandir_smhSelect")
			self.litButton:SetBackdropColor(0, 0, 1, 1)
		end
	end

	SMH.ChangeOfTarget = function(self)
		local targetName = UnitName('target') or ''
		self.currentTargetText:SetText(self.colorGreen .. SMH_S.SPELLUI_TARGET_TEXT .. self.colorStop .. targetName)
		if nil ~= self.litUnit and UnitIsUnit(self.litUnit, 'target') then
			self.grid:SendStatusLost(UnitName(self.litUnit), "com_mithrandir_smhSelect")
			self.litButton:SetBackdropColor(0, 1, 0, 1)
		end
	end

	SMH.ClearLitButton = function(self)
		if nil ~= self.litButton then
			self.litButton:SetBackdropColor(0, 0, 0, 0.125)
			self.litButton = nil
		end
	end

	SMH.GetClearcastingRank = function(self, spellName, desiredRank, myMana, clearcastingBuff)
		local retval = desiredRank

		--	Deteremine whether the spell rank would normally have to be lowered based on mana
		local maxRankManaAllows = desiredRank
		while (maxRankManaAllows > 0) do
			if myMana >= self.cachedSpellBookData[spellName][maxRankManaAllows].mana then break end
			maxRankManaAllows = maxRankManaAllows - 1
		end

		--	Determine the highest rank that can be cast within the time limit of Clearcasting
		local highestTimeBasedRank = 1
		while (self.cachedSpellBookData[spellName][highestTimeBasedRank]) do
			if clearcastingBuff.lifetime < self.cachedSpellBookData[spellName][highestTimeBasedRank].castTime then break end
			highestTimeBasedRank = highestTimeBasedRank + 1
		end
		highestTimeBasedRank = highestTimeBasedRank - 1

		if highestTimeBasedRank > maxRankManaAllows then retval = highestTimeBasedRank else retval = maxRankManaAllows end

		if desiredRank ~= retval then self:OutputMessage("DEBUG", "For " .. spellName .. " decided we want rank " .. desiredRank .. " but Clearcasting (" .. clearcastingBuff.lifetime .. " secs) and mana of " .. myMana .. " changed the rank to " .. retval) end

		return retval
	end

	-- 	This routine attempts to get a spell and rank to heal the unit in the
	--	groupInfo structure.  It will return nil if it cannot find any spell
	--	that meets all the algorithm requirements.
	SMH.GetSpellFromAlgorithm = function(self, groupInfo, playerBuffs)
		local spellName = nil
		local spellRank = nil
		local baseSpells = self:DetermineSpells(groupInfo, nil, playerBuffs)
		local currentConfiguration = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local trulyDesiredRank
		local needsToCheckMana = true
		local canRaiseToMax = true
		local casterHasNaturesSwiftness = (playerBuffs[SMH_S.NATURES_SWIFTNESS] ~= nil)
		local casterHasFocus = (playerBuffs[SMH_S.FOCUS] ~= nil)
		local casterHasBurningAdrenaline = (playerBuffs[SMH_S.BURNING_ADRENALINE] ~= nil)
		local casterHasClearcasting = (playerBuffs[SMH_S.CLEARCASTING] ~= nil)
		local hasInstantCast = casterHasNaturesSwiftness or casterHasFocus or casterHasBurningAdrenaline
		local myMana = UnitMana('player')
		local targetLevel = UnitLevel(groupInfo.id)
		local targetBuffs
		if (groupInfo.id == 'player') then targetBuffs = playerBuffs else targetBuffs = self:UnitBuffs(groupInfo.id) end

		for spellName, structure in ipairs(baseSpells) do

			-- now alter the rank based on overhealing
			trulyDesiredRank = structure.rank
			local amountToAttemptToRaise = currentConfiguration.overhealRanks[spellName]
			if switches.amountToAttemptToRaise > 0 then
				while (self.cachedSpellBookData[spellName][structure.rank] and switches.amountToAttemptToRaise > 0) do
					structure.rank = structure.rank + 1
					amountToAttemptToRaise = amountToAttemptToRaise - 1
				end
				if not self.cachedSpellBookData[spellName][structure.rank] and structure.rank > 0 then
					structure.rank = structure.rank - 1
				end
				if trulyDesiredRank ~= structure.rank then
					self:OutputMessage("DEBUG", "For "..spellName.." we really wanted rank "..trulyDesiredRank.." but overheal raised that to rank ".. structure.rank ..".")
				end
			end

			-- now we make sure we raise the spell to the minimum rank desired
			if structure.rank > 0 then
				local rankToUse = currentConfiguration.minRaiseHealRanks[spellName]
				while (rankToUse > 0 and not self.cachedSpellBookData[spellName][rankToUse]) do
					rankToUse = rankToUse - 1
				end
				if structure.rank < rankToUse then
					self:OutputMessage("DEBUG", "For "..spellName.." we wanted to use rank ".. structure.rank.." but configuration requires us to use rank ".. rankToUse..".")
					structure.rank = rankToUse
				end
			end			

			--	We need to check to ensure we have enough mana to cast the spell.  There
			--	are a few things that make the check unneeded, and if we have free casting
			--	then we can raise the rank to as high as needed.
			trulyDesiredRank = structure.rank		--	record what we really want because we may change it...

			if playerBuffs[SMH_S.INNER_FOCUS] ~= nil or playerBuffs[SMH_S.SPIRIT_OF_REDEMPTION] ~= nil then
				needsToCheckMana = false
			end

			--	Clearcasting will be used to raise the rank of the spell as long as the cast time for
			--	the rank is less than the time remaining on the Clearcasting
			if casterHasClearcasting and self.class ~= SMH_E.SHAMAN and (self.class ~= SMH_E.PRIEST or spellName == SMH_S.FLASH_HEAL or spellName == SMH_S.FAKE_COMBINED_HEAL) then
				needsToCheckMana = false
				canRaiseToMax = false
				structure.rank = self:GetClearcastingRank(spellName, trulyDesiredRank, myMana, playerBuffs[SMH_S.CLEARCASTING])
			end

			-- now check to ensure we have enough mana to cast the desired spell
			if needsToCheckMana then
				while (structure.rank > 0) do
					if (myMana >= self.cachedSpellBookData[spellName][structure.rank].mana) then break end
					structure.rank = structure.rank - 1
				end
				if (trulyDesiredRank ~= structure.rank) then
					self:OutputMessage("DEBUG", "For "..spellName.." decided we want rank "..trulyDesiredRank.." but mana limits us to rank ".. structure.rank..".")
				end
			elseif canRaiseToMax then
				while (self.cachedSpellBookData[spellName][structure.rank]) do
					structure.rank = structure.rank + 1
				end
				structure.rank = structure.rank - 1		-- get back to where we have a spell
				if (trulyDesiredRank ~= structure.rank) then
					self:OutputMessage("DEBUG", "For "..spellName.." decided we want rank "..trulyDesiredRank.." but Inner Focus/Spirit of Redemption allows us to use our highest rank ".. structure.rank..".")
				end
			end

			-- now check to ensure spell can be cast on level of target
			trulyDesiredRank = structure.rank
			if (structure.rank > 0) then
				while (structure.rank > 0) do
					if (targetLevel + 10 >= self.cachedSpellTargetLevels[spellName][structure.rank]) then break end
					structure.rank = structure.rank - 1
				end
				if (trulyDesiredRank ~= structure.rank) then
					self:OutputMessage("DEBUG", "For "..spellName.." "..UnitName(groupInfo.id).." is only level "..targetLevel.." so had to reduce rank from "..trulyDesiredRank.." to rank ".. structure.rank..".")
				end
			end

			-- now we make sure we are not exceeding the maximum rank of spell we are configured to use
			trulyDesiredRank = structure.rank
			if structure.rank > 0 then
				rankToUse = currentConfiguration.maxHealRanks[spellName]
				if structure.rank > rankToUse then
					self:OutputMessage("DEBUG", "For "..spellName.." we wanted to use rank "..trulyDesiredRank.." but configuration limits us to use rank ".. rankToUse..".")
					structure.rank = rankToUse
				end
			end

			-- now we make sure we are at least meeting our minimum expectations for rank of this spell
			if structure.rank > 0 then
				rankToUse = currentConfiguration.minHealRanks[spellName]
				if structure.rank < rankToUse then
					self:OutputMessage("DEBUG", "For "..spellName.." we wanted to use rank ".. structure.rank.." but configuration requires us to use rank ".. rankToUse..", therefore will not use this spell.")
					structure.rank = 0
				end
			end

		end

		if not currentConfiguration.castsExistingHOT then
			-- eliminate Regrowth if we trust it is being cast on the recipient
			if self.class == SMH_E.DRUID then
				if currentConfiguration.otherHealerConfidence >= 50 and self.gettingRegrowthSoon[UnitName(groupInfo.id)] then
					baseSpells[SMH_S.REGROWTH].rank = 0
					self:OutputMessage("DEBUG", "Eliminated Regrowth because we trust someone else is casting it.")
				end
			end
		end

		-- if we are moving and do not have Nature's Swiftness we are limited to instant spells
		if self.isMoving and not hasInstantCast then
			if self.class == SMH_E.DRUID then
				baseSpells[SMH_S.REGROWTH].rank = 0
				baseSpells[SMH_S.HEALING_TOUCH].rank = 0
				self:OutputMessage("DEBUG", "We are moving without Nature\'s Swiftness/Focus so are limited to Rejuvenation and Lifebloom.")
			elseif self.class == SMH_E.PALADIN then
				baseSpells[SMH_S.HOLY_LIGHT].rank = 0
				baseSpells[SMH_S.FLASH_OF_LIGHT].rank = 0
				self:OutputMessage("DEBUG", "We are moving without Focus so cannot heal.")
			elseif self.class == SMH_E.PRIEST then
				baseSpells[SMH_S.BINDING_HEAL].rank = 0
				baseSpells[SMH_S.LESSER_HEAL].rank = 0
				baseSpells[SMH_S.FAKE_COMBINED_HEAL].rank = 0
				baseSpells[SMH_S.FLASH_HEAL].rank = 0
				self:OutputMessage("DEBUG", "We are moving without Focus so are limited to Renew.")
			elseif self.class == SMH_E.SHAMAN then
				baseSpells[SMH_S.CHAIN_HEAL].rank = 0
				baseSpells[SMH_S.HEALING_WAVE].rank = 0
				baseSpells[SMH_S.LESSER_HEALING_WAVE].rank = 0
				self:OutputMessage("DEBUG", "We are moving without Nature\'s Swiftness/Focus so cannot heal.")
			end
		end

		if not currentConfiguration.castsExistingHOT then
			-- eliminate spells the target already has
			if self.class == SMH_E.DRUID then
				if targetBuffs[SMH_S.REGROWTH] ~= nil then
					baseSpells[SMH_S.REGROWTH].rank = 0
					self:OutputMessage("DEBUG", UnitName(groupInfo.id).." already has Regrowth")
				end
				if targetBuffs[SMH_S.REJUVENATION] ~= nil then
					baseSpells[SMH_S.REJUVENATION].rank = 0
					self:OutputMessage("DEBUG", UnitName(groupInfo.id).." already has Rejuvenation")
				end
			elseif self.class == SMH_E.PRIEST then
				if targetBuffs[SMH_S.RENEW] ~= nil then
					baseSpells[SMH_S.RENEW].rank = 0
					self:OutputMessage("DEBUG", UnitName(groupInfo.id).." already has Renew")
				end
			end
		end

		-- now we use our algorithm to determine the spell to cast
		local temp = { }
		for n in pairs(currentConfiguration.algorithm) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareGreaterNumeric(a, b) end)
		for i, n in ipairs(temp) do 
			if (groupInfo.percent * 100) > tonumber(n) then
				self:OutputMessage("DEBUG", string.format("The groupinfo percentage is %d and the table shows %s...a match", groupInfo.percent * 100, n))
				if baseSpells[currentConfiguration.algorithm[n]].rank > 0 then
					spellName = currentConfiguration.algorithm[n]
					self:OutputMessage("DEBUG", string.format("We have found the spell to use in table %s %s", n, spellName))
					break
				end
				--	We now also control whether the break should happen based on the algorithmFallthrough configuration variable.
				if not currentConfiguration.algorithmFallthrough then
					break
				end
			end
		end

		-- if no spell has been found using the algorithm do into our default spell list
		if (spellName == nil) then
			local tableSize = table.getn(currentConfiguration.defaultSpells)
			for i = 1, tableSize do
				if currentConfiguration.defaultSpells[i][2] and baseSpells[currentConfiguration.defaultSpells[i][1]].rank > 0 then
					spellName = currentConfiguration.defaultSpells[i][1]
					break
				end
			end
		end

		if spellName then spellRank = baseSpells[spellName].rank end

		return spellName, spellRank
	end

	SMH.Help = function(self)
		local helpCount = table.getn(SMH_S.HELP_LINES)
		for i = 1, helpCount, 1 do
			self:OutputMessage("INFO", string.format(SMH_S.HELP_LINES[i], self.addonMacroCommand))
		end
	end

	--	This routine starts the whole process of determining who to heal
	--	and with what.
	SMH.InitiateHeal = function(self)
		self:ClearLitButton()
		if nil ~= self.litUnit then
			self.grid:SendStatusLost(UnitName(self.litUnit), "com_mithrandir_smhSelect")
			self.litUnit = nil
		end
		if UnitOnTaxi('player') == 1 then self:CannotCast(SMH_S.ABORT_MESSAGE_ON_TAXI); return end
		if UnitIsDead('player') then self:CannotCast(SMH_S.ABORT_MESSAGE_DEAD); return end
		local playerBuffs = self:UnitBuffs('player')
		if self.class == SMH_E.DRUID and self:IsShapeshifted(playerBuffs) then self:CannotCast(SMH_S.ABORT_MESSAGE_SHAPESHIFTED); return end
		if self.class == SMH_E.PRIEST and self:IsShadowform(playerBuffs) then self:CannotCast(SMH_S.ABORT_MESSAGE_SHAPESHIFTED); return end
		if self.class == SMH_E.PRIEST and nil ~= playerBuffs[SMH_S.CORRUPTED_HEALING] then self:CannotCast(string.format(SMH_S.ABORT_MESSAGE_BAD_BUFF, SMH_S.CORRUPTED_HEALING)); return end
		if self.class == SMH_E.SHAMAN and self:IsGhostWold(playerBuffs) then self:CannotCast(SMH_S.ABORT_MESSAGE_SHAPESHIFTED); return end
		if self:IsMounted(playerBuffs) then self:CannotCast(SMH_S.ABORT_MESSAGE_MOUNTED); return end
		local aCastStoppingBuff = self:CastStoppingBuff(playerBuffs)
		if aCastStoppingBuff then self:CannotCast(string.format(SMH_S.ABORT_MESSAGE_BAD_BUFF, aCastStoppingBuff)); return end
		self.currentGroupStatus = self:OrderedHealableUnits()
		if table.getn(self.currentGroupStatus) > 0 then
			for key, value in ipairs(self.currentGroupStatus) do
				local unitName = UnitName(value.id) or 'UNKNOWN'
				local isPlayer = (value.id == 'player')
				self.determinedUnit = value.id
				local foundUnit = value.id
				local targetBuffs

				-- ensure unit is in range, assuming the player is always within range of self :-)
				if not isPlayer then
					if IsSpellInRange(self.spellForRangeTesting, "spell", foundUnit) ~= 1 then foundUnit = nil end
				end
				if foundUnit then
					if not isPlayer then targetBuffs = self:UnitBuffs(foundUnit) else targetBuffs = playerBuffs end
					if nil == targetBuffs[SMH_S.DIVINE_INTERVENTION] then
						if nil == targetBuffs[SMH_S.PETRIFICATION] then
							if nil == targetBuffs[SMH_S.SPIRIT_OF_REDEMPTION] then
								if nil == targetBuffs[SMH_S.PHASE_SHIFT] then
									if nil == targetBuffs[SMH_S.PROWL] or self:UnitInParty(foundUnit) then
										if nil == targetBuffs[SMH_S.STEALTH] or self:UnitInParty(foundUnit) then
											if nil == targetBuffs[SMH_S.SHADOWMELD] or self:UnitInParty(foundUnit) then
												self.determinedSpellName, self.determinedSpellRank = self:GetSpellFromAlgorithm(value, playerBuffs)
												if self.determinedSpellName then
													self.litButton = self.spellButtonBacks[self.determinedSpellName][self.determinedSpellRank]
													if UnitIsUnit('player', foundUnit) then
														self.litButton:SetBackdropColor(1, 0.5, 0, 1)
													elseif UnitIsUnit('target', foundUnit) then
														self.litButton:SetBackdropColor(0, 1, 0, 1)
													elseif UnitIsUnit('focus', foundUnit) then
														self.litButton:SetBackdropColor(0, 0, 1, 1)
													else
														self.litUnit = foundUnit
														self.grid:SendStatusGained(UnitName(self.litUnit), "com_mithrandir_smhSelect", 99, 40, { r=1, g=0, b=0, a=1 }, "", 100, 100, nil)
													end
													break;
												else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_NO_SPELLFORMAT, unitName)) end
											else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.SHADOWMELD)) end
										else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.STEALTH)) end
									else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.PROWL)) end
								else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.PHASE_SHIFT)) end
							else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.SPIRIT_OF_REDEMPTION)) end
						else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.PETRIFICATION)) end
					else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_UNDER_EFFECT, unitName, SMH_S.DIVINE_INTERVENTION)) end
				else self:OutputMessage("INFO", string.format(SMH_S.INFORMATIVE_MESSAGE_OORFORMAT, unitName)) end
			end
		else
			self:OutputMessage("INFO", SMH_S.INFORMATIVE_MESSAGE_NO_ONE)
			self.currentGroupStatus = nil
		end
	end

	SMH.IsGhostWolf = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		if playerBuffs[SMH_S.GHOST_WOLF] ~= nil then retval = true end
		return retval
	end

	SMH.IsMounted = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		for n in pairs(playerBuffs) do if playerBuffs[n]["mounted"] then retval = true; break end end
		return retval
	end

	SMH.IsShapeshifted = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		for n in pairs(playerBuffs) do if self.shapeshiftBuffs[n] then retval = true; break end end
		return retval
	end

	SMH.IsShadowform = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		if playerBuffs[SMH_S.SHADOWFORM] ~= nil then retval = true end
		return retval
	end

	SMH.MainFrame_OnEvent = function(self)
		if self.eventMainDispatch[event] then
			self.eventMainDispatch[event](self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
		end
	end

	SMH.MainFrame_OnLoad = function(self)
		if self.classesPermittedToUseAddon[self.class] then
			SlashCmdList["SMH"] = function(msg)
				self:SlashCommand(msg)
			end
			SLASH_SMH1 = self.addonMacroCommand
			this:SetScript("OnEvent", function() self:MainFrame_OnEvent() end)
			this:RegisterEvent("PLAYER_ENTERING_WORLD")
			this:RegisterEvent("VARIABLES_LOADED")
			this:RegisterEvent("PLAYER_TARGET_CHANGED")
			this:RegisterEvent("PLAYER_FOCUS_CHANGED")
			this:RegisterEvent("PLAYER_REGEN_ENABLED")	-- only used to ensure spell buttons are not updated in combat
			this:RegisterEvent("UNIT_SPELLCAST_SENT")
			this:RegisterEvent("UNIT_SPELLCAST_FAILED")
			this:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
			this:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		end
	end

	SMH.MainFrame_OnUpdate = function(self)
		local positionX, positionY = GetPlayerMapPosition('player')
		if positionX ~= self.lastX or positionY ~= self.lastY then self.isMoving = true else self.isMoving = false end
		self.lastX = positionX
		self.lastY = positionY
	end

	--	All parameters are passed in the msg string.  Therefore, if we have options to our own
	--	commands we need to split them out.
	SMH.SlashCommand = function(self, msg)
		if (msg == nil or msg == "") then
			self:InitiateHeal()
		else
			msg = string.lower(msg)
			-- hopefully this means we will have command and options filled in such as:
			-- /smh msg => command="msg" options=nil
			-- /smh msg on => command="msg" options="on"
			local _, _, command, options = string.find(msg, "^%s*([%a:]+)%s*(%a*)")
			if command ~= nil then
				if self.commandFunctions[command] then
					self.commandFunctions[command]()
				end
			end
		end
	end

	--	This routine is only used for testing different things
	--	out and has no real purpose other than allowing me to
	--	have a test harness available relatively easily.
	SMH.Test = function(self)

	end

	SMH.UpdateSpells = function(self)
		local frame = com_mithrandir_smhMainFrame
		local numberOfRows = 0
		local maxColumns = 0
		local numberInRow
		local button
		local texture
		for i = 1, table.getn(self.classSpellsOfInterest[self.class]), 1 do
			if nil ~= self.cachedSpellBookData[self.classSpellsOfInterest[self.class][i]] then
				numberInRow = table.getn(self.cachedSpellBookData[self.classSpellsOfInterest[self.class][i]])
			else
				numberInRow = 0
			end
			if numberInRow > 0 then
				if nil == self.spellForRangeTesting then
					self.spellForRangeTesting = self.cachedSpellBookData[self.classSpellsOfInterest[self.class][i]][1].id
				end
				numberOfRows = numberOfRows + 1
				if numberInRow > maxColumns then maxColumns = numberInRow end
				for j = 1, numberInRow, 1 do
					local buttonTable = self.spellButtons[self.classSpellsOfInterest[self.class][i]]
					if nil == buttonTable then
						self.spellButtons[self.classSpellsOfInterest[self.class][i]] = { }
						buttonTable = self.spellButtons[self.classSpellsOfInterest[self.class][i]]
						self.spellButtonBacks[self.classSpellsOfInterest[self.class][i]] = { }
					end
					button = self.spellButtons[self.classSpellsOfInterest[self.class][i]][j]
					if nil == button then
						-- create the button background that will be colored appropriately
						self.spellButtonBacks[self.classSpellsOfInterest[self.class][i]][j] = CreateFrame("Button", nil, frame)
						button = self.spellButtonBacks[self.classSpellsOfInterest[self.class][i]][j]
						button:SetWidth(30); button:SetHeight(30)
						button:SetBackdrop({ bgFile = "Interface\\Addons\\SMH\\white16x16", tile = true, tileSize = 16, })  -- TGA file taken from Grid, thanks.
						button:SetBackdropColor(0, 0, 0, 0.125)
						button:EnableMouse(nil)
						-- create the button that actually casts the spell when clicked
						button = CreateFrame("Button", nil, frame, "SecureActionButtonTemplate")
						button:SetNormalTexture(self.cachedSpellBookData[self.classSpellsOfInterest[self.class][i]][j].texture)
						button:SetWidth(24); button:SetHeight(24)
						button:SetAttribute("unit1", "target")
						button:SetAttribute("type", "spell")
						button:SetAttribute("spell", self.classSpellsOfInterest[self.class][i] .. "(Rank " .. j .. ")")
						-- I cannot seem to get right click to work properly, nor ctl click.  Therefore, we use alt for self
						-- and shift for focus.  Because we specify exactly unit1 above versus unit we get the desired behavior
						-- of not putting ourselves in cast mode if there is no target.  And because the general type and spell
						-- are used they do not need to be duplicated for the alt and shift forms.
						button:SetAttribute("alt-unit1", "player")
						button:SetAttribute("shift-unit1", "focus")
						self.spellButtons[self.classSpellsOfInterest[self.class][i]][j] = button
					end
					button:SetPoint("TOPLEFT", frame, "TOPLEFT", (j - 1) * 30 + 15, -55 - ((numberOfRows - 1) * 30))
					self.spellButtonBacks[self.classSpellsOfInterest[self.class][i]][j]:SetPoint("TOPLEFT", frame, "TOPLEFT", (j - 1) * 30 + 12, -52 - ((numberOfRows - 1) * 30))
				end
			end
		end
		frame:SetHeight((numberOfRows * 30) + 70)
		if maxColumns < 4 then maxColumns = 4 end
		frame:SetWidth((maxColumns * 30) + 25)
	end

end
