--	SMH - Simply Magical Healer
--	Options
--	Written by scott@mithrandir.com
--	Official website:  http://www.mithrandir.com/WorldOfWarcraft/WoW.html
--

SMH_Options_File_Version = 09940

if nil == SMH.addonOptionsVersionNumber or SMH.addonOptionsVersionNumber < SMH_Options_File_Version then

	SMH_Configuration = { }

	SMH.addonOptionsVersionNumber = SMH_Options_File_Version
	SMH.algorithmAddingSpell = nil
	SMH.allClasses = { SMH_S.DRUID, SMH_S.HUNTER, SMH_S.MAGE, SMH_S.PALADIN, SMH_S.PRIEST, SMH_S.ROGUE, SMH_S.SHAMAN, SMH_S.WARLOCK, SMH_S.WARRIOR }
	SMH.buttonsAlgorithm = { }
	SMH.buttonsAlgorithmCast = { }
	SMH.buttonsAlgorithmControl = { }
	SMH.buttonsProfile = { }
	SMH.buttonsProfileAppears = { }
	SMH.colorBlue = "|cFF0000FF"
	SMH.colorGreen = "|cFF00FF00"
	SMH.colorRed = "|cFFFF0000"
	SMH.colorYellow = "|cFFFFFF00"
	SMH.colorStop = "|r"
	SMH.configurationDefaults = {
		["healsFocus"] = false,			-- indicates whether the focus has a high priority
		["druidCatsAsRogues"] = false,		-- indicates whether Druids in Cat form are to be treated as the class Rogue
		["druidBearsAsWarriors"] = false,	-- indicates whether Druids in Bear form are to be treated as the class Warrior
		["castsExistingHOT"] = false,		-- indicates whether a check is made for HOT spells that exist before casting one of the same type
		["targetPriority"] = true,		-- indicates whether the "target" has priority over all else
		["healPercentage"] = 50,		-- indicates the percentage of the possible heal range to use to compare to the target's health
		["healingPets"] = true,			-- indicates whether party pets are considered in the healing list
		["threshold"] = 100,			-- indicates percentage of health target must be below to be considered for healing
		["petThreshold"] = 100,			-- indicates percentage of health pets must be below to be considered for healing
		["selfThreshold"] = 40,			-- indicates percentage of health self must be below to be forced to head of healing list
		["healingRaid"] = true,			-- indicates whether raid members are to be healed
		["healingRaidPets"] = true,		-- indicates whether raid pets are to be healed
		["partyOverRaid"] = true,		-- indicates whether the party has priority over the raid for healing
		["healsParty"] = true,			-- indicates whether party members other than self are healed
		["minimapButtonAngle"] = 356,		-- indicates the angle around the minimap for the location of the button that toggles options UI
		["priorityRaidPets"] = false,		-- indicates that pets of groups that have priority get the same priority
		["raidPriorities"] = { [1] = 2, [2] = 2, [3] = 2, [4] = 2, [5] = 2, [6] = 2, [7] = 2, [8] = 2, },
		["classPriorities"] = {
			[SMH_S.DRUID] = 2,
			[SMH_S.HUNTER] = 2,
			[SMH_S.MAGE] = 2,
			[SMH_S.PALADIN] = 2,
			[SMH_S.PRIEST] = 2,
			[SMH_S.ROGUE] = 2,
			[SMH_S.SHAMAN] = 2,
			[SMH_S.WARLOCK] = 2,
			[SMH_S.WARRIOR] = 2,
			},				-- indicates the priority that classes have
		["classPriorityOverParty"] = false,	-- indicates high priority classes have higher priority than party members
		["charactersPriorityHigh"] = { },	-- indicates characters that have the highest priority
		["charactersPriorityLow"] = { },	-- indicates characters that have low priority
		["charactersPriorityIgnored"] = { },	-- indicates characters that will not be healed
		["shouldDisplayProfile"] = false,	-- indicates whether the profile will be displayed in the mini profile window
		["outOfGroup"] = true,			-- indicates whether high priority characters are healed even if party and/or raid are not
		["healsTargetsTarget"] = false,		-- indicates whether the target's target is healed
		["doNotHealBelowLevel"] = 1,		-- indicates the level below which characters will not be healed
		["classHealPercents"] = {
			[SMH_S.DRUID] = 100,
			[SMH_S.HUNTER] = 100,
			[SMH_S.MAGE] = 100,
			[SMH_S.PALADIN] = 100,
			[SMH_S.PRIEST] = 100,
			[SMH_S.ROGUE] = 100,
			[SMH_S.SHAMAN] = 100,
			[SMH_S.WARLOCK] = 100,
			[SMH_S.WARRIOR] = 100,
			},				-- indicates the healing percentages that classes have (for underheal and overheal)
		["otherHealerConfidence"] = 100,	-- indicates how confident one is in the amount being healed by other SMH users...as a percentage
		["algorithmFallthrough"] = false,	-- indicates whether the algorithm will fall through to the next choice if current not allowed
		["messagePlaces"] = {
			["CAST"] = 4,
			["INFO"] = 1,
			["ERROR"] = 1,
			["TIER"] = 0,
			["DEBUG"] = 0,
			["CASTNOPARTY"] = 1,
			},				-- indicates the default placement of message types
		}
	SMH.currentTab = 0				-- indicates current tab for use for refresh when profile changes
	-- We maintain a list of icons even though it is a pain when new spells are added or if for some
	-- reason Blizzard changes the icon because we cannot use the textures from the spell book because
	-- the character may not yet have the spell and we still want to be able to have its icon present
	-- in the UI.
	SMH.defaultSpellIcons = {
		[SMH_S.REGROWTH] = "Interface\\Icons\\Spell_Nature_ResistNature",
		[SMH_S.REJUVENATION] = "Interface\\Icons\\Spell_Nature_Rejuvenation",
		[SMH_S.HEALING_TOUCH] = "Interface\\Icons\\Spell_Nature_HealingTouch",
		[SMH_S.LIFEBLOOM] = "Interface\\Icons\\INV_Misc_Herb_Felblossom",
		[SMH_S.HOLY_LIGHT] = "Interface\\Icons\\Spell_Holy_HolyBolt",
		[SMH_S.FLASH_OF_LIGHT] = "Interface\\Icons\\Spell_Holy_FlashHeal",
		[SMH_S.BINDING_HEAL] = "Interface\\Icons\\Spell_Holy_BlindingHeal",
		[SMH_S.LESSER_HEAL] = "Interface\\Icons\\Spell_Holy_LesserHeal",
		[SMH_S.FAKE_COMBINED_HEAL] = "Interface\\Icons\\Spell_Holy_GreaterHeal",
		[SMH_S.RENEW] = "Interface\\Icons\\Spell_Holy_Renew",
		[SMH_S.FLASH_HEAL] = "Interface\\Icons\\Spell_Holy_FlashHeal",
		[SMH_S.CHAIN_HEAL] = "Interface\\Icons\\Spell_Nature_HealingWaveGreater",
		[SMH_S.HEALING_WAVE] = "Interface\\Icons\\Spell_Nature_MagicImmunity",
		[SMH_S.LESSER_HEALING_WAVE] = "Interface\\Icons\\Spell_Nature_HealingWaveLesser",
		}
	SMH.eventOptionsDispatch = {
		['VARIABLES_LOADED'] = function(self)
			self:Options_Init()
		end,
		}
	SMH.maxNumberInAlgColumn = 10			-- maximum number of spells in the algorithm column
	SMH.maxNumberInColumn = 10			-- maximum number of character names in each priority column
	SMH.maxNumberInProColumn = 10			-- maximum number of profiles in the profile column
	SMH.messageLabels = {
		SMH.colorRed .. SMH_S.MESSAGE_LABEL_NONE .. SMH.colorStop,
		SMH_S.MESSAGE_LABEL_CHAT,
		SMH_S.MESSAGE_LABEL_COMBAT,
		SMH_S.MESSAGE_LABEL_ERROR,
		SMH.colorBlue .. SMH_S.MESSAGE_LABEL_PARTY .. SMH.colorStop,
		}
	SMH.messageTitles = { SMH_S.MESSAGE_TYPE_CAST, SMH_S.MESSAGE_TYPE_INFO, SMH_S.MESSAGE_TYPE_ERROR, SMH_S.MESSAGE_TYPE_TIER, SMH_S.MESSAGE_TYPE_DEBUG, SMH_S.MESSAGE_TYPE_CAST_NO_PARTY, }
	SMH.messageTypes = { "CAST", "INFO", "ERROR", "TIER", "DEBUG", "CASTNOPARTY", }
	SMH.petIds = { pet = 0, partypet1 = 1, partypet2 = 2, partypet3 = 3, partypet4 = 4 }
	SMH.playerIds = { party1 = 1, party2 = 2, party3 = 3, party4 = 4 }
	SMH.priorityCharacterHigh = { }			-- the buttons for high priority characters
	SMH.priorityCharacterIgnored = { }		-- the buttons for ignored priority characters
	SMH.priorityCharacterLow = { }			-- the buttons for low priority characters
	SMH.priorityLabels = {
		SMH.colorRed .. SMH_S.PRIORITY_LABEL_IGNORED .. SMH.colorStop,
		SMH.colorYellow .. SMH_S.PRIORITY_LABEL_LOW .. SMH.colorStop,
		SMH.colorGreen .. SMH_S.PRIORITY_LABEL_NORMAL .. SMH.colorStop,
		SMH.colorBlue .. SMH_S.PRIORITY_LABEL_HIGH .. SMH.colorStop,
		}
	SMH.tabs = { }
	SMH.uiElements = { }

	SMH.Algorithm_Add = function(self)
		local percentageValue = com_mithrandir_smhAlgorithmAcceptField:GetText()

		if tonumber(percentageValue) >= 0 and tonumber(percentageValue) <= 99 then
			SMH_Configuration.profiles[SMH_Configuration.currentProfile].algorithm[percentageValue] = self.algorithmAddingSpell
			self:AlgorithmButtons_Show()
		end
	end

	SMH.Algorithm_Control = function(self)
		if self:RealTableSize(SMH_Configuration.profiles[SMH_Configuration.currentProfile].algorithm) < self.maxNumberInAlgColumn then
			self.algorithmAddingSpell = this.tooltiptext
			com_mithrandir_smhAlgorithmAcceptInfo:SetText(string.format(SMH_S.ALGORITHM_INSTRUCTIONS, self.algorithmAddingSpell))
			com_mithrandir_smhAlgorithmAccept:Show()
		end
	end

	SMH.Algorithm_Remove = function(self)
		local buttonTitle = this:GetText()
		local match, _, amount = string.find(buttonTitle, "^(%d+)%%.*")
		if (match ~= nil) then
			SMH_Configuration.profiles[SMH_Configuration.currentProfile].algorithm[amount] = nil
			self:AlgorithmButtons_Show()
		end
	end

	SMH.AlgorithmButtons_Hide = function(self)
		for i = 1, self.maxNumberInAlgColumn, 1 do
			self.buttonsAlgorithm[i]:Hide()
		end
	end

	SMH.AlgorithmButtons_Show = function(self)
		local temp = { }
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		for n in pairs(currentProfile.algorithm) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareGreaterNumeric(a, b) end)
		for i, n in ipairs(temp) do
			self.buttonsAlgorithm[i]:SetText(string.format("%s%% %s", n, currentProfile.algorithm[n]))
			self.buttonsAlgorithm[i]:Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInAlgColumn, 1 do
			self.buttonsAlgorithm[i]:Hide()
		end
	end

	SMH.CharacterPriorityButtons_Hide = function(self)
		for i = 1, self.maxNumberInColumn, 1 do
			self.priorityCharacterHigh[i]:Hide()
			self.priorityCharacterIgnored[i]:Hide()
			self.priorityCharacterLow[i]:Hide()
		end
	end

	SMH.CharacterPriorityButtons_Show = function(self)
		local temp = { }
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		for n in pairs(currentProfile.charactersPriorityIgnored) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			self.priorityCharacterIgnored[i]:SetText(n)
			self.priorityCharacterIgnored[i]:Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInColumn, 1 do
			self.priorityCharacterIgnored[i]:Hide()
		end

		temp = { }
		for n in pairs(currentProfile.charactersPriorityLow) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			self.priorityCharacterLow[i]:SetText(n)
			self.priorityCharacterLow[i]:Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInColumn, 1 do
			self.priorityCharacterLow[i]:Hide()
		end

		temp = { }
		for n in pairs(currentProfile.charactersPriorityHigh) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			self.priorityCharacterHigh[i]:SetText(n)
			self.priorityCharacterHigh[i]:Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInColumn, 1 do
			self.priorityCharacterHigh[i]:Hide()
		end
	end

	SMH.CharacterPriority_Add = function(self)
		if self:UnitIsHealable('target') then
			local targetName = UnitName('target')
			local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
			if currentProfile.charactersPriorityHigh[targetName] then currentProfile.charactersPriorityHigh[targetName] = nil end
			if currentProfile.charactersPriorityLow[targetName] then currentProfile.charactersPriorityLow[targetName] = nil end
			if currentProfile.charactersPriorityIgnored[targetName] then currentProfile.charactersPriorityIgnored[targetName] = nil end
			local id = this:GetID()
			if id == 0 then
				if self:RealTableSize(currentProfile.charactersPriorityIgnored) < self.maxNumberInColumn then
					currentProfile.charactersPriorityIgnored[targetName] = true
				end
			elseif id == 1 then
				if self:RealTableSize(currentProfile.charactersPriorityLow) < self.maxNumberInColumn then
					currentProfile.charactersPriorityLow[targetName] = true
				end
			elseif id == 2 then
				if self:RealTableSize(currentProfile.charactersPriorityHigh) < self.maxNumberInColumn then
					currentProfile.charactersPriorityHigh[targetName] = true
				end
			end
			self:CharacterPriorityButtons_Show()
		end
	end

	SMH.CharacterPriority_Remove = function(self)
		local id = this:GetID()
		local characterName = this:GetText()
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if id < 100 then
			currentProfile.charactersPriorityIgnored[characterName] = nil
		elseif id < 200 then
			currentProfile.charactersPriorityLow[characterName] = nil
		else
			currentProfile.charactersPriorityHigh[characterName] = nil
		end
		self:CharacterPriorityButtons_Show()
	end

	SMH.CheckButton_OnClick = function(self)
		local key = SMH_S.CHECK_BUTTON_TITLES[this:GetID()][1]
		SMH_Configuration.profiles[SMH_Configuration.currentProfile][key] = (this:GetChecked() == 1)
	end

	SMH.CheckButton_OnShow = function(self)
		if SMH_Configuration.profiles[SMH_Configuration.currentProfile][SMH_S.CHECK_BUTTON_TITLES[this:GetID()][1]] then
			this:SetChecked(1)
		else
			this:SetChecked(0)
		end
	end

	SMH.CompareGreater = function(self, one, two)
		return one > two
	end

	SMH.CompareGreaterNumeric = function(self, one, two)
		return tonumber(one) > tonumber(two)
	end

	SMH.CompareHealth = function(self, unit1, unit2)
		return unit1.percent < unit2.percent
	end

	SMH.CompareLesser = function(self, one, two)
		return one < two
	end

	SMH.ConfirmationDialog_Template = function(self, frameName, parent, acceptFunction, acceptText, cancelText, title, info, needsEditBox)
		local frame = CreateFrame("Frame", frameName, parent)
		frame:SetWidth(400); frame:SetHeight(150); frame:SetFrameStrata("DIALOG"); frame:SetToplevel(1); frame:EnableMouse(1); frame:SetMovable(1); frame:Hide()
		frame:SetPoint("CENTER", "UIParent")
		frame:SetBackdrop({ bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, edgeSize = 32, tileSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 } })
		local texture = frame:CreateTexture(frameName .. "HeaderTexture", "ARTWORK")
		texture:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")
		texture:SetWidth(256); texture:SetHeight(64)
		texture:SetPoint("TOP", 0, 12)
		local titleString = frame:CreateFontString(frameName .. "Title", "ARTWORK", "GameFontNormal")
		titleString:SetPoint("TOP", texture, "TOP", 0, -14)
		titleString:SetText(title)
		local infoString = frame:CreateFontString(frameName .. "Info", "ARTWORK", "GameFontNormal")
		infoString:SetWidth(350); infoString:SetHeight(32); infoString:SetJustifyV("TOP")
		infoString:SetPoint("TOP", 0, -30)
		infoString:SetText(info)
		if needsEditBox then
			local editBox = CreateFrame("EditBox", frameName .. "Field", frame, "InputBoxTemplate")
			editBox:SetWidth(60); editBox:SetHeight(17); editBox:SetAutoFocus(1)
			editBox:SetPoint("CENTER", infoString, "CENTER", 0, -30)
		end
		local addButton = CreateFrame("Button", frameName .. "AddButton", frame, "GameMenuButtonTemplate")
		addButton:SetWidth(80); addButton:SetHeight(21)
		addButton:SetPoint("BOTTOM", frame, "BOTTOM", -60, 12)
		addButton:SetText(acceptText)
		addButton:SetScript("OnClick", function() acceptFunction(); frame:Hide() end)
		local cancelButton = CreateFrame("Button", frameName .. "CancelButton", frame, "GameMenuButtonTemplate")
		cancelButton:SetWidth(80); cancelButton:SetHeight(21)
		cancelButton:SetPoint("BOTTOM", frame, "BOTTOM", 60, 12)
		cancelButton:SetText(cancelText)
		cancelButton:SetScript("OnClick", function() frame:Hide() end)
		return frame
	end

	SMH.DealWithUnsureRecipient = function(self, where, who)
		if self:UnitInGroup(who) then
			self:TryToInsertUnitForHealing(where, who, "threshold", nil)
		else
			local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
			local characterName = UnitName(who)
			self:ProcessOtherHeals()
			local possibleHealingForUnit = self.currentOtherHealsByCharacter[characterName]
			if possibleHealingForUnit == nil then possibleHealingForUnit = 0 end
			-- for a target not in the party, UnitHealth returns the percentage of maximum health
			-- so we must make a guess at how much is gone based on the target's class and level
			local slope = (self.maxClassHealth[UnitClass(who)] - 30) / 69
			local targetMaxHealth = UnitLevel(who) * slope + 30
			local targetCurrentHealth = targetMaxHealth * (UnitHealth(who) / 100) + possibleHealingForUnit * (currentProfile.otherHealerConfidence / 100)
			local targetPercentHealth = targetCurrentHealth / targetMaxHealth
			if targetPercentHealth < (currentProfile.threshold / 100.0) then
				table.insert(where, 1, { id = who, percent = targetPercentHealth, current = targetCurrentHealth, max = targetMaxHealth })
				local message = "The " .. who .. " " .. UnitName(who) .. " put into heal list."
				self:OutputMessage("DEBUG", message)
				self:OutputMessage("TIER", message)
			end
		end
	end

	--	If forcing it means we overwrite whatever was stored
	SMH.Defaults_Update = function(self, forcing)
		if forcing then
			for key in pairs(self.configurationDefaults) do
				SMH_Configuration.profiles[SMH_Configuration.currentProfile][key] = self.configurationDefaults[key]
			end
		else
			-- Ensure each profile has the proper keys present
			for profile in pairs(SMH_Configuration.profiles) do
				-- Make sure each default key is present in the profile
				for key in pairs(self.configurationDefaults) do
					if (nil == SMH_Configuration.profiles[profile][key]) then
						SMH_Configuration.profiles[profile][key] = self.configurationDefaults[key]
					end
				end
				-- Remove any key from the profile that does not exist in the defaults
				for key in pairs(SMH_Configuration.profiles[profile]) do
					if (nil == self.configurationDefaults[key]) then
						SMH_Configuration.profiles[profile][key] = nil
					end
				end
			end
		end
	end

	SMH.Frame_Update = function(self)
		for i = 1, getn(SMH_S.OPTION_TABS), 1 do self.tabs[i]:Show() end
	end

	SMH.LookupOrderedProfileName = function(self, whichOne)
		local retval = nil
		local temp = { }

		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		retval = temp[whichOne]
		return retval
	end

	SMH.MiniCheckButton_OnClick = function(self)
		SMH_Configuration.profiles[SMH_Configuration.currentProfile].defaultSpells[this:GetID()][2] = (this:GetChecked() == 1)
	end

	SMH.MiniCheckButton_OnShow = function(self)
		if SMH_Configuration.profiles[SMH_Configuration.currentProfile].defaultSpells[this:GetID()][2] then
			this:SetChecked(1)
		else
			this:SetChecked(0)
		end
	end

	SMH.MinimapButton_Create = function(self)
		local frame = CreateFrame("Button", nil, Minimap)
		frame:SetWidth(32)
		frame:SetHeight(32)
		frame:SetFrameStrata("MEDIUM")
		frame:SetPoint("TOPLEFT", Minimap, "TOPLEFT")
		frame:RegisterForClicks("LeftButtonUp", "RightButtonUp")
		frame:SetScript("OnClick", function() self:MiniMapButton_OnClick() end)
		frame:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
		local texture = frame:CreateTexture(nil, "ARTWORK")
		texture:SetTexture("Interface\\AddOns\\SMH_Options\\smhMiniButton")
		texture:SetWidth(32)
		texture:SetHeight(32)
		texture:SetPoint("TOPLEFT", frame, "TOPLEFT")
		local overlay = frame:CreateTexture(nil, "OVERLAY")
		overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
		overlay:SetWidth(53)
		overlay:SetHeight(53)
		overlay:SetPoint("TOPLEFT", frame, "TOPLEFT")
		self.minimapButton = frame
	end

	SMH.MiniMapButton_OnClick = function(self)
		self:Options_ShowHide()
	end

	SMH.MiniMapButton_UpdatePosition = function(self)
		local angle = SMH_Configuration.profiles[SMH_Configuration.currentProfile].minimapButtonAngle
		self.minimapButton:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 52 - (80 * cos(angle)), (80 * sin(angle)) - 52)
	end

	SMH.MiniProfile_Create = function(self)
		local frameName = "com_mithrandir_smhMiniProfiles"
		local frame = CreateFrame("Frame", frameName, UIParent)
		frame:SetWidth(180)
		frame:SetHeight(30)
		frame:SetFrameStrata("LOW")
		frame:SetToplevel(1)
		frame:EnableMouse(1)
		frame:SetMovable(1)
		frame:SetPoint("TOP", 0, -50)
		local region = frame:CreateTitleRegion()
		region:SetAllPoints(frame)
		frame:SetBackdrop({ bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16, insets = { left = 5, right = 5, top = 5, bottom = 5 } })
		local string = frame:CreateFontString(frameName .. "Text", "OVERLAY", "GameFontNormal")
		string:SetPoint("TOP", frame, "TOP", 0, -7)
		string:SetText(SMH_S.PROFILE_MINI_TITLE)
		local button = self:TemplateButton_Profile(frameName .. "ListItem1", frame, 1)
		button:SetPoint("TOPLEFT", frame, "BOTTOMLEFT", 5, 0)
		for i = 2, self.maxNumberInProColumn do
			local newButton = self:TemplateButton_Profile(frameName .. "ListItem" .. i, frame, i)
			newButton:SetPoint("TOPLEFT", button, "BOTTOMLEFT", 0, 1)
			button = newButton
		end
	end

	SMH.MiniProfile_NameInDisplayPosition = function(self, whichOne)
		local temp = { }

		for n in pairs(SMH_Configuration.profiles) do
			if SMH_Configuration.profiles[n]["shouldDisplayProfile"] then
				table.insert(temp, n)
			end
		end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		return temp[whichOne]
	end

	SMH.MiniProfile_Set = function(self)
		local profileName = self:MiniProfile_NameInDisplayPosition(this:GetID())
		self:Profile_SetName(profileName)
		self:MiniProfile_Update()
		if com_mithrandir_smhOptions:IsVisible() then
			self:Tab_Set(SMH.currentTab)
		end
	end

	SMH.MiniProfile_Update = function(self)
		local temp = { }
		local count = 0

		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			if SMH_Configuration.profiles[n]["shouldDisplayProfile"] then
				count = count + 1
				if SMH_Configuration.currentProfile == n then
					getglobal("com_mithrandir_smhMiniProfilesListItem"..count):SetText(self.colorGreen .. n .. self.colorStop)
				else
					getglobal("com_mithrandir_smhMiniProfilesListItem"..count):SetText(n)
				end
				getglobal("com_mithrandir_smhMiniProfilesListItem"..count):Show()
			end
		end
		for i = count + 1, self.maxNumberInProColumn, 1 do
			getglobal("com_mithrandir_smhMiniProfilesListItem"..i):Hide()
		end
		if count > 1 then com_mithrandir_smhMiniProfiles:Show()	else com_mithrandir_smhMiniProfiles:Hide() end
	end

	SMH.Options_Init = function(self)

		--	Here we populate the default configuration information
		--	with data that is class specific.
		if self.class == SMH_E.DRUID then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_S.REJUVENATION,
				["50"] = SMH_S.REGROWTH,
				["25"] = SMH_S.HEALING_TOUCH,
				["0"] = SMH_S.REGROWTH,
				}
			self.configurationDefaults.defaultSpells = { 
				{ SMH_S.REJUVENATION, true },
				{ SMH_S.REGROWTH, true },
				{ SMH_S.HEALING_TOUCH, true },
				{ SMH_S.LIFEBLOOM, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_S.REJUVENATION] = 0,
				[SMH_S.REGROWTH] = 0,
				[SMH_S.HEALING_TOUCH] = 0,
				[SMH_S.LIFEBLOOM] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_S.REJUVENATION] = table.getn(self.levelLearned[SMH_S.REJUVENATION]),
				[SMH_S.REGROWTH] = table.getn(self.levelLearned[SMH_S.REGROWTH]),
				[SMH_S.HEALING_TOUCH] = table.getn(self.levelLearned[SMH_S.HEALING_TOUCH]),
				[SMH_S.LIFEBLOOM] = table.getn(self.levelLearned[SMH_S.LIFEBLOOM]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_S.REJUVENATION] = 1,
				[SMH_S.REGROWTH] = 1,
				[SMH_S.HEALING_TOUCH] = 1,
				[SMH_S.LIFEBLOOM] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_S.REJUVENATION] = 1,
				[SMH_S.REGROWTH] = 1,
				[SMH_S.HEALING_TOUCH] = 1,
				[SMH_S.LIFEBLOOM] = 1,
				}
		elseif self.class == SMH_E.PALADIN then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_S.HOLY_LIGHT,
				["0"] = SMH_S.FLASH_OF_LIGHT,
				}
			self.configurationDefaults.defaultSpells = { 
				{ SMH_S.FLASH_OF_LIGHT, true },
				{ SMH_S.HOLY_LIGHT, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_S.FLASH_OF_LIGHT] = 0,
				[SMH_S.HOLY_LIGHT] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_S.FLASH_OF_LIGHT] = table.getn(self.levelLearned[SMH_S.FLASH_OF_LIGHT]),
				[SMH_S.HOLY_LIGHT] = table.getn(self.levelLearned[SMH_S.HOLY_LIGHT]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_S.FLASH_OF_LIGHT] = 1,
				[SMH_S.HOLY_LIGHT] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_S.FLASH_OF_LIGHT] = 1,
				[SMH_S.HOLY_LIGHT] = 1,
				}
		elseif self.class == SMH_E.PRIEST then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_S.FLASH_HEAL,
				["0"] = SMH_S.GREATER_HEAL,
				}
			self.configurationDefaults.defaultSpells = {
				{ SMH_S.FAKE_COMBINED_HEAL, true },
				{ SMH_S.LESSER_HEAL, true },
				{ SMH_S.RENEW, true },
				{ SMH_S.FLASH_HEAL, true },
				{ SMH_S.BINDING_HEAL, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_S.FAKE_COMBINED_HEAL] = 0,
				[SMH_S.LESSER_HEAL] = 0,
				[SMH_S.RENEW] = 0,
				[SMH_S.FLASH_HEAL] = 0,
				[SMH_S.BINDING_HEAL] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_S.FAKE_COMBINED_HEAL] = table.getn(self.levelLearned[SMH_S.FAKE_COMBINED_HEAL]),
				[SMH_S.LESSER_HEAL] = table.getn(self.levelLearned[SMH_S.LESSER_HEAL]),
				[SMH_S.RENEW] = table.getn(self.levelLearned[SMH_S.RENEW]),
				[SMH_S.FLASH_HEAL] = table.getn(self.levelLearned[SMH_S.FLASH_HEAL]),
				[SMH_S.BINDING_HEAL] = table.getn(self.levelLearned[SMH_S.BINDING_HEAL]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_S.FAKE_COMBINED_HEAL] = 1,
				[SMH_S.LESSER_HEAL] = 1,
				[SMH_S.RENEW] = 1,
				[SMH_S.FLASH_HEAL] = 1,
				[SMH_S.BINDING_HEAL] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_S.FAKE_COMBINED_HEAL] = 1,
				[SMH_S.LESSER_HEAL] = 1,
				[SMH_S.RENEW] = 1,
				[SMH_S.FLASH_HEAL] = 1,
				[SMH_S.BINDING_HEAL] = 1,
				}
		elseif self.class == SMH_E.SHAMAN then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_S.LESSER_HEALING_WAVE,
				["0"] = SMH_S.HEALING_WAVE,
				}
			self.configurationDefaults.defaultSpells = { 
				{ SMH_S.HEALING_WAVE, true },
				{ SMH_S.LESSER_HEALING_WAVE, true },
				{ SMH_S.CHAIN_HEAL, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_S.CHAIN_HEAL] = 0,
				[SMH_S.HEALING_WAVE] = 0,
				[SMH_S.LESSER_HEALING_WAVE] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_S.CHAIN_HEAL] = table.getn(self.levelLearned[SMH_S.CHAIN_HEAL]),
				[SMH_S.HEALING_WAVE] = table.getn(self.levelLearned[SMH_S.HEALING_WAVE]),
				[SMH_S.LESSER_HEALING_WAVE] = table.getn(self.levelLearned[SMH_S.LESSER_HEALING_WAVE]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_S.CHAIN_HEAL] = 1,
				[SMH_S.HEALING_WAVE] = 1,
				[SMH_S.LESSER_HEALING_WAVE] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_S.CHAIN_HEAL] = 1,
				[SMH_S.HEALING_WAVE] = 1,
				[SMH_S.LESSER_HEALING_WAVE] = 1,
				}
		end

		--	Check to ensure we actually have a saved variable file and if not create
		--	a default one.
		if nil == SMH_Configuration or self:RealTableSize(SMH_Configuration) < 2 then
			SMH_Configuration.currentProfile = SMH_S.DEFAULT_PROFILE_NAME
			SMH_Configuration.profiles = { }
			SMH_Configuration.profiles[SMH_Configuration.currentProfile] = self:CopyTable(self.configurationDefaults)
		end

		--	In version 0.9.7 we have added profiles and therefore we need to detect whether the
		--	SMH_Configuration that is read in has the proper profiles set up and if not we take
		--	the stored values and convert them to a default profile.
		if nil == SMH_Configuration.currentProfile then
			local temp = { }
			for key in pairs(SMH_Configuration) do
				temp[key] = SMH_Configuration[key]
				SMH_Configuration[key] = nil
			end
			SMH_Configuration.currentProfile = SMH_S.DEFAULT_PROFILE_NAME
			SMH_Configuration.profiles = { }
			SMH_Configuration.profiles[SMH_Configuration.currentProfile] = temp
		end

		--	In version 0.9.9.1 we have switched control over where messages are sent to sliders
		--	for the different types of messages.  Therefore, we need to set the default values
		--	for each of the saved profiles for these message places based on the switch settings.
		local temp = { }
		local messageLocation
		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		for i, n in ipairs(temp) do
			if nil ~= SMH_Configuration.profiles[n].messagesParty or nil ~= SMH_Configuration.profiles[n].debug or SMH_Configuration.profiles[n].messagesChat or SMH_Configuration.profiles[n].combatViceChat then
				--	first create the basic structure
				SMH_Configuration.profiles[n].messagePlaces = { }
				for key in pairs(self.configurationDefaults.messagePlaces) do SMH_Configuration.profiles[n].messagePlaces[key] = self.configurationDefaults.messagePlaces[key] end
				--	then configure it based on the profile's settings
				messageLocation = 0
				if SMH_Configuration.profiles[n].messagesChat then messageLocation = 1 end
				if SMH_Configuration.profiles[n].combatViceChat then messageLocation = 2 end
				if SMH_Configuration.profiles[n].debug then
					local debugLocation = messageLocation
					if debugLocation == 0 then debugLocation = 1 end
					SMH_Configuration.profiles[n].messagePlaces["DEBUG"] = debugLocation
				end
				if not SMH_Configuration.profiles[n].messagesParty then
					SMH_Configuration.profiles[n].messagePlaces["CAST"] = messageLocation
				end
				SMH_Configuration.profiles[n].messagePlaces["INFO"] = messageLocation
				SMH_Configuration.profiles[n].messagePlaces["ERROR"] = messageLocation
				SMH_Configuration.profiles[n].messagePlaces["CASTNOPARTY"] = messageLocation
			end

			--	In version 0.9.9.2 we have added the capability to ignore default spells so
			--	we must make sure all previous versions have their data structures include
			--	the required information.
			if type(SMH_Configuration.profiles[n].defaultSpells[1]) ~= 'table' then
				local newTable = { }
				for j = 1, table.getn(SMH_Configuration.profiles[n].defaultSpells), 1 do
					newTable[j] = { SMH_Configuration.profiles[n].defaultSpells[j], true }
				end
				SMH_Configuration.profiles[n].defaultSpells = newTable
			end

			--	In version 0.9.9.4 we have added limited support for the Druid's Lifebloom
			--	so must make sure the data structures include it.
			if self.class == SMH_E.DRUID then
				if table.getn(SMH_Configuration.profiles[n].defaultSpells) < 4 then
					table.insert(SMH_Configuration.profiles[n].defaultSpells, { SMH_S.LIFEBLOOM, true })
					SMH_Configuration.profiles[n].maxHealRanks[SMH_S.LIFEBLOOM] = table.getn(self.levelLearned[SMH_S.LIFEBLOOM])
					SMH_Configuration.profiles[n].minHealRanks[SMH_S.LIFEBLOOM] = 1
					SMH_Configuration.profiles[n].minRaiseHealRanks[SMH_S.LIFEBLOOM] = 1
					SMH_Configuration.profiles[n].overhealRanks[SMH_S.LIFEBLOOM] = 0
				end
			end

			--	In version 0.9.9.3 we have added limited support for the Shaman's Chain Heal
			--	so must make sure the data structures include it.
			if self.class == SMH_E.SHAMAN then
				if table.getn(SMH_Configuration.profiles[n].defaultSpells) < 3 then
					table.insert(SMH_Configuration.profiles[n].defaultSpells, { SMH_S.CHAIN_HEAL, true })
					SMH_Configuration.profiles[n].maxHealRanks[SMH_S.CHAIN_HEAL] = table.getn(self.levelLearned[SMH_S.CHAIN_HEAL])
					SMH_Configuration.profiles[n].minHealRanks[SMH_S.CHAIN_HEAL] = 1
					SMH_Configuration.profiles[n].minRaiseHealRanks[SMH_S.CHAIN_HEAL] = 1
					SMH_Configuration.profiles[n].overhealRanks[SMH_S.CHAIN_HEAL] = 0
				end
			end

			--	In version 0.9.9.3 we have converted the automatic casting of Nature's Swiftness
			--	into a slider based on health instead of a check box so we convert the value here.
			if not SMH_Configuration.profiles[n].castThresholdNaturesSwiftness then
				if SMH_Configuration.profiles[n].checkingNaturesSwiftness then
					SMH_Configuration.profiles[n].castThresholdNaturesSwiftness = 100
				else
					SMH_Configuration.profiles[n].castThresholdNaturesSwiftness = 0
				end
			end
			SMH_Configuration.profiles[n].checkingNaturesSwiftness = nil

			--	In version 0.9.9.4 we have changed the raid priority system to have values like
			--	those used for class priorities and therefore we need to take any older settings
			--	and switch them.
			if nil ~= SMH_Configuration.profiles[n].priorityRaidGroup1 then
				SMH_Configuration.profiles[n].raidPriorities = { }
				for j = 1, 8, 1 do
					if SMH_Configuration.profiles[n]["priorityRaidGroup" .. j] then
						SMH_Configuration.profiles[n].raidPriorities[j] = 3
					else
						SMH_Configuration.profiles[n].raidPriorities[j] = 2
					end
				end
			end

		end

		self:Defaults_Update(false)

		--	If the current profile does not actually exist in the set of profiles
		--	we set the current profile to something that does exist.
		if nil == SMH_Configuration.profiles[SMH_Configuration.currentProfile] then
			self:Profile_SetName(self:Profile_First())
		end

		--	In version 0.9.8 we have combined Greater Heal and Heal into one fake spell so this
		--	means all earlier profiles will need to be adjusted to ensure the old spells are removed
		--	and replaced properly with the new fake spell.  This includes defaultSpells, algorithm
		--	and overhealRanks.
		if self.class == SMH_E.PRIEST then
			local temp = { }

			for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
			for i, n in ipairs(temp) do

				--	Ensure overhealRanks are updated.
				if nil ~= SMH_Configuration.profiles[n].overhealRanks[SMH_S.HEAL] then
					SMH_Configuration.profiles[n].overhealRanks[SMH_S.HEAL] = nil
					SMH_Configuration.profiles[n].overhealRanks[SMH_S.FAKE_COMBINED_HEAL] = SMH_Configuration.profiles[n].overhealRanks[SMH_S.GREATER_HEAL]
					SMH_Configuration.profiles[n].overhealRanks[SMH_S.GREATER_HEAL] = nil
				end

				--	Ensure defaultSpells are updated.
				local temp2 = { }
				local healLocation = nil
				for nn in pairs(SMH_Configuration.profiles[n].defaultSpells) do table.insert(temp2, nn) end
				for ii, nn in ipairs(temp2) do
					local spellName = SMH_Configuration.profiles[n].defaultSpells[nn][1]
					if spellName == SMH_S.GREATER_HEAL then
						SMH_Configuration.profiles[n].defaultSpells[nn][1] = SMH_S.FAKE_COMBINED_HEAL
					elseif spellName == SMH_S.HEAL then
						healLocation = nn
					end
				end
				if nil ~= healLocation then
					for j = healLocation, table.getn(temp2) - 1, 1 do
						SMH_Configuration.profiles[n].defaultSpells[j] = SMH_Configuration.profiles[n].defaultSpells[j + 1]
					end
					SMH_Configuration.profiles[n].defaultSpells[table.getn(temp2)] = nil
				end

				--	In 0.9.9.4 Power Word: Shield and Desperate Prayer were removed so any presence of them should be removed
				--	Remove from defaultSpells
				local newTable = { }
				local newIndex = 1
				for j = 1, table.getn(SMH_Configuration.profiles[n].defaultSpells), 1 do
					local spellName = SMH_Configuration.profiles[n].defaultSpells[j][1]
					if spellName ~= SMH_S.POWER_WORD_SHIELD and spellName ~= SMH_S.DESPERATE_PRAYER then
						newTable[newIndex] = SMH_Configuration.profiles[n].defaultSpells[j]
						newIndex = newIndex + 1
					end
				end
				SMH_Configuration.profiles[n].defaultSpells = newTable
				--	Remove from algorithm
				newTable = { }
				local temp2 = { }
				for nn in pairs(SMH_Configuration.profiles[n].algorithm) do table.insert(temp2, nn) end
				for ii, nn in ipairs(temp2) do
					local spellName = SMH_Configuration.profiles[n].algorithm[nn]
					if spellName ~= SMH_S.POWER_WORD_SHIELD and spellName ~= SMH_S.DESPERATE_PRAYER then
						newTable[nn] = spellName
					end
				end
				SMH_Configuration.profiles[n].algorithm = newTable
				SMH_Configuration.profiles[n].maxHealRanks[SMH_S.DESPERATE_PRAYER] = nil
				SMH_Configuration.profiles[n].minHealRanks[SMH_S.DESPERATE_PRAYER] = nil
				SMH_Configuration.profiles[n].minRaiseHealRanks[SMH_S.DESPERATE_PRAYER] = nil
				SMH_Configuration.profiles[n].overhealRanks[SMH_S.DESPERATE_PRAYER] = nil

				--	Ensure algorithm is updated.
				local temp2 = { }
				for nn in pairs(SMH_Configuration.profiles[n].algorithm) do table.insert(temp2, nn) end
				for ii, nn in ipairs(temp2) do
					local spellName = SMH_Configuration.profiles[n].algorithm[nn]
					if spellName == SMH_S.HEAL or spellName == SMH_S.GREATER_HEAL then
						SMH_Configuration.profiles[n].algorithm[nn] = SMH_S.FAKE_COMBINED_HEAL
					end
				end

				--	In version 0.9.9.4 we have added limited support for the Priest's Binding Heal
				--	so must make sure the data structures include it.
				if table.getn(SMH_Configuration.profiles[n].defaultSpells) < 5 then
					table.insert(SMH_Configuration.profiles[n].defaultSpells, { SMH_S.BINDING_HEAL, true })
					SMH_Configuration.profiles[n].maxHealRanks[SMH_S.BINDING_HEAL] = table.getn(self.levelLearned[SMH_S.BINDING_HEAL])
					SMH_Configuration.profiles[n].minHealRanks[SMH_S.BINDING_HEAL] = 1
					SMH_Configuration.profiles[n].minRaiseHealRanks[SMH_S.BINDING_HEAL] = 1
					SMH_Configuration.profiles[n].overhealRanks[SMH_S.BINDING_HEAL] = 0
				end

			end
		end

		self:MinimapButton_Create()
		self:MiniMapButton_UpdatePosition()

		local button
		local oldButton
		local string
		local frame
		local slider
		local oldSlider

		-- create the title for the options panel
		string = com_mithrandir_smhOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", com_mithrandir_smhOptions, "TOPLEFT", 90, -19)
		string:SetText("|cFFFF0000S|rimply |cFFFF0000M|ragical |cFFFF0000H|realer - Options")

		-- create the title for the current profile
		self.stringCurrentProfile = com_mithrandir_smhOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		self.stringCurrentProfile:SetPoint("TOPLEFT", com_mithrandir_smhOptions, "TOPLEFT", 90, -39)
		self:Profile_NameUpdate()

		-- creat the title for the current +healing
		self.stringCurrentHealing = com_mithrandir_smhOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		self.stringCurrentHealing:SetPoint("TOPLEFT", com_mithrandir_smhOptions, "TOPLEFT", 90, -54)
		self:UpdateTotalPlusHealingText()
		self:RegisterForNotification(SMH_E.NOTIFICATION_EQUIPMENT_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)
		self:RegisterForNotification(SMH_E.NOTIFICATION_SPIRITUAL_GUIDANCE_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)
		self:RegisterForNotification(SMH_E.NOTIFICATION_BUFF_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)
		self:RegisterForNotification(SMH_E.NOTIFICATION_NATURES_BLESSING_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)
		self:RegisterForNotification(SMH_E.NOTIFICATION_HOLY_GUIDANCE_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)
		self:RegisterForNotification(SMH_E.NOTIFICATION_LUNAR_GUIDANCE_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)
		self:RegisterForNotification(SMH_E.NOTIFICATION_NURTURING_INSTINCT_MODIFICATION_CHANGED, function() self:UpdateTotalPlusHealingText() end)

		-- create the close button for the options panel
		frame = CreateFrame("Button", nil, com_mithrandir_smhOptions, "UIPanelCloseButton")
		frame:SetPoint("CENTER", com_mithrandir_smhOptions, "TOPRIGHT", -44, -26)

		-- create the general UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -90)
		string:SetText(SMH_S.MessageText)
		table.insert(self.uiElements, { string, 1 })
		local slider1 = self:TemplateSlider_Small("com_mithrandir_smhMessageCast", frame, 601)
		slider1:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { slider1, 1 })
		local slider2 = self:TemplateSlider_Small("com_mithrandir_smhMessageCastNoParty", frame, 606)
		slider2:SetPoint("TOPLEFT", slider1, "TOPLEFT", 150, 0)
		table.insert(self.uiElements, { slider2, 1 })
		local slider3 = self:TemplateSlider_Small("com_mithrandir_smhMessageInfo", frame, 602)
		slider3:SetPoint("TOPLEFT", slider1, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { slider3, 1 })
		local slider4 = self:TemplateSlider_Small("com_mithrandir_smhMessageError", frame, 603)
		slider4:SetPoint("TOPLEFT", slider2, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { slider4, 1 })
		local slider5 = self:TemplateSlider_Small("com_mithrandir_smhMessageTier", frame, 604)
		slider5:SetPoint("TOPLEFT", slider3, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { slider5, 1 })
		local slider6 = self:TemplateSlider_Small("com_mithrandir_smhMessageDebug", frame, 605)
		slider6:SetPoint("TOPLEFT", slider4, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { slider6, 1 })
		local slider7 = self:TemplateSlider_Large("com_mithrandir_smhMiniButtonAngle", frame, 5)
		slider7:SetPoint("TOPLEFT", slider5, "TOPLEFT", 0, -45)
		table.insert(self.uiElements, { slider7, 1 })
		button = self:TemplateCheckButton("com_mithrandir_smhCastsExistingHOT", frame, 1)
		button:SetPoint("TOPLEFT", slider7, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button, 1 })
		button = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
		button:SetText(SMH_S.ResetOptions)
		button:SetPoint("BOTTOM", frame, "BOTTOM", 0, 100)
		button:SetScript("OnClick", function() com_mithrandir_smhResetAccept:Show() end)
		table.insert(self.uiElements, { button, 1 })

		-- create the healing UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 35, -90)
		string:SetText(SMH_S.HealsText)
		table.insert(self.uiElements, { string, 2 })
		local button2 = self:TemplateCheckButton("com_mithrandir_smhUsesTarget", frame, 7)
		button2:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -10)
		table.insert(self.uiElements, { button2, 2 })
		local button3 = self:TemplateCheckButton("com_mithrandir_smhHealsTargetsTarget", frame, 18)
		button3:SetPoint("TOPLEFT", button2, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button3, 2 })
		local button4 = self:TemplateCheckButton("com_mithrandir_smhHealsParty", frame, 6)
		button4:SetPoint("TOPLEFT", button2, "TOPLEFT", 110, 0)
		table.insert(self.uiElements, { button4, 2 })
		local button5 = self:TemplateCheckButton("com_mithrandir_smhHealsPets", frame, 5)
		button5:SetPoint("TOPLEFT", button4, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button5, 2 })
		local button6 = self:TemplateCheckButton("com_mithrandir_smhHealingRaid", frame, 4)
		button6:SetPoint("TOPLEFT", button4, "TOPLEFT", 90, 0)
		table.insert(self.uiElements, { button6, 2 })
		local button7 = self:TemplateCheckButton("com_mithrandir_smhHealingRaidPets", frame, 3)
		button7:SetPoint("TOPLEFT", button6, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button7, 2 })
		string = frame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 35, -160)
		string:SetText(SMH_S.PrioritiesText)
		table.insert(self.uiElements, { string, 2 })
		local button8 = self:TemplateCheckButton("com_mithrandir_smhPartyPriority", frame, 2)
		button8:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -10)
		table.insert(self.uiElements, { button8, 2 })
		local button9 = self:TemplateCheckButton("com_mithrandir_smhClassHighPriority", frame, 17)
		button9:SetPoint("TOPLEFT", button8, "TOPLEFT", 120, 0)
		table.insert(self.uiElements, { button9, 2 })
		local slider14 = self:TemplateSlider_Large("com_mithrandir_smhDamageThreshold", frame, 1)
		slider14:SetPoint("TOPLEFT", button8, "TOPLEFT", 0, -42)
		table.insert(self.uiElements, { slider14, 2 })
		local slider15 = self:TemplateSlider_Large("com_mithrandir_smhPetDamageThreshold", frame, 2)
		slider15:SetPoint("TOPLEFT", slider14, "TOPLEFT", 0, -31)
		table.insert(self.uiElements, { slider15, 2 })
		local slider16 = self:TemplateSlider_Large("com_mithrandir_smhSelfDamageThreshold", frame, 3)
		slider16:SetPoint("TOPLEFT", slider15, "TOPLEFT", 0, -31)
		table.insert(self.uiElements, { slider16, 2 })
		local slider17 = self:TemplateSlider_Large("com_mithrandir_smhHealPercentage", frame, 4)
		slider17:SetPoint("TOPLEFT", slider16, "TOPLEFT", 0, -31)
		table.insert(self.uiElements, { slider17, 2 })
		local slider18 = self:TemplateSlider_Large("com_mithrandir_smhIgnoreLevel", frame, 6)
		slider18:SetPoint("TOPLEFT", slider17, "TOPLEFT", 0, -31)
		table.insert(self.uiElements, { slider18, 2 })
		local slider19 = self:TemplateSlider_Large("com_mithrandir_smhConfidence", frame, 7)
		slider19:SetPoint("TOPLEFT", slider18, "TOPLEFT", 0, -31)
		table.insert(self.uiElements, { slider19, 2 })

		-- create the algorithm UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 210, -100)
		string:SetText(SMH_S.AlgorithmCastText)
		table.insert(self.uiElements, { string, 3 })
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -100)
		string:SetText(SMH_S.AlgorithmText)
		table.insert(self.uiElements, { string, 3 })
		self.buttonsAlgorithmControl[1] = self:TemplateButton_AlgCtl(nil, frame)
		self.buttonsAlgorithmControl[1]:SetPoint("TOPLEFT", string, "TOPLEFT", 210, 0)
		table.insert(self.uiElements, { self.buttonsAlgorithmControl[1], 3 })
		self.buttonsAlgorithmCast[1] = self:TemplateCheckButton_Mini(nil, frame, 1)
		self.buttonsAlgorithmCast[1]:SetPoint("TOPLEFT", self.buttonsAlgorithmControl[1], "TOPLEFT", -20, -10)
		table.insert(self.uiElements, { self.buttonsAlgorithmCast[1], 3 })
		for i = 2, 6, 1 do
			self.buttonsAlgorithmControl[i] = self:TemplateButton_AlgCtl(nil, frame)
			self.buttonsAlgorithmControl[i]:SetPoint("TOPLEFT", self.buttonsAlgorithmControl[i - 1], "TOPLEFT", 0, -45)
			self.buttonsAlgorithmCast[i] = self:TemplateCheckButton_Mini(nil, frame, i)
			self.buttonsAlgorithmCast[i]:SetPoint("TOPLEFT", self.buttonsAlgorithmControl[i], "TOPLEFT", -20, -10)
			button = self:TemplateButton_DefaultLeft(nil, frame)
			button:SetPoint("TOPLEFT", self.buttonsAlgorithmControl[i], "TOPLEFT", 45, -5)
			local j = i - 1
			button:SetScript("OnClick", function() self:SwapDefaultSpells(j , j + 1) end)
			if self:ShouldInsertSpell(i) then
				table.insert(self.uiElements, { self.buttonsAlgorithmControl[i], 3 })
				table.insert(self.uiElements, { self.buttonsAlgorithmCast[i], 3 })
				table.insert(self.uiElements, { button, 3 })
			end
		end
		self.buttonsAlgorithm[0] = string
		for i = 1, self.maxNumberInAlgColumn, 1 do
			self.buttonsAlgorithm[i] = self:TemplateButton_Algorithm(nil, frame)
			self.buttonsAlgorithm[i]:SetPoint("TOPLEFT", self.buttonsAlgorithm[i - 1], "TOPLEFT", 0, -20)
		end
		button = self:TemplateCheckButton("com_mithrandir_smhAlgorithmFallthrough", frame, 27)
		button:SetPoint("TOPLEFT", self.buttonsAlgorithm[self.maxNumberInAlgColumn], "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button, 3 })
		self.buttonsAlgorithm[0] = nil
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetWidth(290); string:SetHeight(90)
		string:SetPoint("TOPLEFT", 40, -350)
		string:SetText(SMH_S.DefaultInstructionText)
		table.insert(self.uiElements, { string, 3 })

		-- create the character priority UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetWidth(290); string:SetHeight(50)
		string:SetPoint("TOPLEFT", 35, -90)
		string:SetText(SMH_S.CharacterPriortyText)
		table.insert(self.uiElements, { string, 4 })
		oldButton = self:TemplateButton_CharacterPriority(nil, frame, 1)
		oldButton:SetPoint("CENTER", string, "CENTER", 0, -30)
		oldButton:SetText(SMH_S.PRIORITY_LABEL_LOW)
		table.insert(self.uiElements, { oldButton, 4 })
		button = self:TemplateButton_CharacterPriority(nil, frame, 0)
		button:SetPoint("TOPLEFT", oldButton, "TOPLEFT", 90, 0)
		button:SetText(SMH_S.PRIORITY_LABEL_IGNORED)
		table.insert(self.uiElements, { button, 4 })
		button = self:TemplateButton_CharacterPriority(nil, frame, 2)
		button:SetPoint("TOPLEFT", oldButton, "TOPLEFT", -90, 0)
		button:SetText(SMH_S.PRIORITY_LABEL_HIGH)
		table.insert(self.uiElements, { button, 4 })
		self.priorityCharacterLow[1] = self:TemplateButton_CharPri(nil, frame, 101)
		self.priorityCharacterLow[1]:SetPoint("TOPLEFT", oldButton, "TOPLEFT", 0, -30)
		self.priorityCharacterHigh[1] = self:TemplateButton_CharPri(nil, frame, 201)
		self.priorityCharacterHigh[1]:SetPoint("TOPLEFT", self.priorityCharacterLow[1], "TOPLEFT", -90, 0)
		self.priorityCharacterIgnored[1] = self:TemplateButton_CharPri(nil, frame, 1)
		self.priorityCharacterIgnored[1]:SetPoint("TOPLEFT", self.priorityCharacterLow[1], "TOPLEFT", 90, 0)
		for i = 2, self.maxNumberInColumn, 1 do
			self.priorityCharacterLow[i] = self:TemplateButton_CharPri(nil, frame, 100 + i)
			self.priorityCharacterLow[i]:SetPoint("TOPLEFT", self.priorityCharacterLow[i - 1], "TOPLEFT", 0, -20)
			self.priorityCharacterHigh[i] = self:TemplateButton_CharPri(nil, frame, 200 + i)
			self.priorityCharacterHigh[i]:SetPoint("TOPLEFT", self.priorityCharacterHigh[i - 1], "TOPLEFT", 0, -20)
			self.priorityCharacterIgnored[i] = self:TemplateButton_CharPri(nil, frame, i)
			self.priorityCharacterIgnored[i]:SetPoint("TOPLEFT", self.priorityCharacterIgnored[i - 1], "TOPLEFT", 0, -20)
		end
		button = self:TemplateCheckButton("com_mithrandir_smhHealsOutOfGroup", frame, 19)
		button:SetPoint("TOPLEFT", self.priorityCharacterHigh[self.maxNumberInColumn], "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button, 4 })

		-- create the class priority UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -90)
		string:SetText(SMH_S.ClassPriorityText)
		table.insert(self.uiElements, { string, 5 })
		local slider12 = self:TemplateSlider_Small("com_mithrandir_smhPriorityDruid", frame, 501)
		slider12:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -30)
		oldSlider = slider12
		table.insert(self.uiElements, { slider12, 5 })
		local slider13 = self:TemplateSlider_Small("com_mithrandir_smhPriorityHunter", frame, 502)
		slider13:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 150, 0)
		oldSlider2 = slider13
		table.insert(self.uiElements, { slider13, 5 })
		local englishClasses = { "Druid", "Hunter", "Mage", "Paladin", "Priest", "Rogue", "Shaman", "Warlock", "Warrior" }
		for i = 3, 9, 2 do
			slider12 = self:TemplateSlider_Small("com_mithrandir_smhPriority" .. englishClasses[i], frame, 500 + i)
			slider12:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider12
			table.insert(self.uiElements, { slider12, 5 })
			if (i < 9) then
				slider13 = self:TemplateSlider_Small("com_mithrandir_smhPriority" .. englishClasses[i + 1], frame, 500 + i + 1)
				slider13:SetPoint("TOPLEFT", oldSlider2, "TOPLEFT", 0, -25)
				oldSlider2 = slider13
				table.insert(self.uiElements, { slider13, 5 })
			end
		end
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -240)
		string:SetText(SMH_S.ClassOverhealingText)
		table.insert(self.uiElements, { string, 5 })
		local slider9 = self:TemplateSlider_Small("com_mithrandir_smhClassOverheal1", frame, 701)
		slider9:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -30)
		oldSlider = slider9
		table.insert(self.uiElements, { slider9, 5 })
		local slider10 = self:TemplateSlider_Small("com_mithrandir_smhClassOverheal2", frame, 702)
		slider10:SetPoint("TOPLEFT", slider9, "TOPLEFT", 150, 0)
		local oldSlider2 = slider10
		table.insert(self.uiElements, { slider10, 5 })
		for i = 3, 9, 2 do
			slider9 = self:TemplateSlider_Small("com_mithrandir_smhClassOverheal" .. i, frame, 700 + i)
			slider9:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider9
			table.insert(self.uiElements, { slider9, 5 })
			if (i < 9) then
				slider10 = self:TemplateSlider_Small("com_mithrandir_smhClassOverheal" .. i + 1, frame, 700 + i + 1)
				slider10:SetPoint("TOPLEFT", oldSlider2, "TOPLEFT", 0, -25)
				oldSlider2 = slider10
				table.insert(self.uiElements, { slider10, 5 })
			end
		end
		button = self:TemplateCheckButton("com_mithrandir_smhDruidCats", frame, 8)
		button:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -20)
		table.insert(self.uiElements, { button, 5 })
		button = self:TemplateCheckButton("com_mithrandir_smhDruidBears", frame, 9)
		button:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 150, -20)
		table.insert(self.uiElements, { button, 5 })

		-- create the raid priority UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -90)
		string:SetText(SMH_S.RaidPriorityText)
		table.insert(self.uiElements, { string, 6 })
		oldSlider = string
		for i = 1, 7, 2 do
			slider = self:TemplateSlider_Small("com_mithrandir_smhRaidPriority" .. i, frame, 800 + i)
			slider:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider
			table.insert(self.uiElements, { slider, 6})
			slider = self:TemplateSlider_Small("com_mithrandir_smhRaidPriority" .. i + 1, frame, 800 + i + 1)
			slider:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 150, 0)
			table.insert(self.uiElements, { slider, 6})
		end
		button = self:TemplateCheckButton("com_mithrandir_smhPriRaidPets", frame, 16)
		button:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -30)
		table.insert(self.uiElements, { button, 6 })

		-- create the profiles UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -100)
		string:SetText(SMH_S.ProfileText)
		table.insert(self.uiElements, { string, 7 })
		self.buttonsProfile[0] = string
		for i = 1, self.maxNumberInProColumn, 1 do
			self.buttonsProfile[i] = self:TemplateButton_Profile(nil, frame, -1)
			self.buttonsProfile[i]:SetPoint("TOPLEFT", self.buttonsProfile[i - 1], "TOPLEFT", 0, -20)
			self.buttonsProfileAppears[i] = self:TemplateCheckButton_Appear("com_mithrandir_smhProfileAppear" .. i, frame, i)
			self.buttonsProfileAppears[i]:SetPoint("TOPLEFT", self.buttonsProfile[i], "TOPLEFT", 200, -1)
		end
		self.buttonsProfile[0] = nil
		oldButton = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
		oldButton:SetWidth(180); oldButton:SetHeight(17)
		oldButton:SetPoint("TOPLEFT", self.buttonsProfile[self.maxNumberInProColumn], "TOPLEFT", 0, -40)
		oldButton:SetText(SMH_S.PROFILE_NEW)
		oldButton:SetScript("OnClick", function() com_mithrandir_smhProfileAccept:Show() end)
		table.insert(self.uiElements, { oldButton, 7 })
		button = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
		button:SetWidth(180); button:SetHeight(17)
		button:SetPoint("TOPLEFT", oldButton, "TOPLEFT", 0, -20)
		button:SetText(SMH_S.PROFILE_DELETE)
		button:SetScript("OnClick", function() com_mithrandir_smhProfileDelete:Show() end)
		table.insert(self.uiElements, { button, 7 })
		button = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
		button:SetWidth(180); button:SetHeight(17)
		button:SetPoint("TOPLEFT", oldButton, "TOPLEFT", 0, -40)
		button:SetText(SMH_S.PROFILE_RENAME)
		button:SetScript("OnClick", function() com_mithrandir_smhProfileRename:Show() end)
		table.insert(self.uiElements, { button, 7 })

		-- create the ranks UI
		frame = com_mithrandir_smhOptions
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -100)
		string:SetText(SMH_S.RankMinRaiseText)
		table.insert(self.uiElements, { string, 8 })
		slider = self:TemplateSlider_Small("com_mithrandir_smhMinRaiseHeal1", frame, 401)
		slider:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -25)
		oldSlider = slider
		table.insert(self.uiElements, { slider, 8 })
		for i = 2, self.classSpellsOfInterestMaxCount, 1 do
			slider = self:TemplateSlider_Small("com_mithrandir_smhMinRaiseHeal" .. i, frame, 400 + i)
			slider:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider
			if self:ShouldInsertSpell(i) then
				table.insert(self.uiElements, { slider, 8 })
			end
		end
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 190, -100)
		string:SetText(SMH_S.RankMaximumText)
		table.insert(self.uiElements, { string, 8 })
		slider = self:TemplateSlider_Small("com_mithrandir_smhMaxHeal1", frame, 201)
		slider:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -25)
		oldSlider = slider
		table.insert(self.uiElements, { slider, 8 })
		for i = 2, self.classSpellsOfInterestMaxCount, 1 do
			slider = self:TemplateSlider_Small("com_mithrandir_smhMaxHeal" .. i, frame, 200 + i)
			slider:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider
			if self:ShouldInsertSpell(i) then
				table.insert(self.uiElements, { slider, 8 })
			end
		end
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 40, -260)
		string:SetText(SMH_S.RankMinimumText)
		table.insert(self.uiElements, { string, 8 })
		slider = self:TemplateSlider_Small("com_mithrandir_smhMinHeal1", frame, 301)
		slider:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -25)
		oldSlider = slider
		table.insert(self.uiElements, { slider, 8 })
		for i = 2, self.classSpellsOfInterestMaxCount, 1 do
			slider = self:TemplateSlider_Small("com_mithrandir_smhMinHeal" .. i, frame, 300 + i)
			slider:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider
			if self:ShouldInsertSpell(i) then
				table.insert(self.uiElements, { slider, 8 })
			end
		end
		string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		string:SetPoint("TOPLEFT", 190, -260)
		string:SetText(SMH_S.RankOverhealText)
		table.insert(self.uiElements, { string, 8 })
		slider = self:TemplateSlider_Small("com_mithrandir_smhOverheal1", frame, 101)
		slider:SetPoint("TOPLEFT", string, "TOPLEFT", 0, -25)
		local oldSlider = slider
		table.insert(self.uiElements, { slider, 8 })
		for i = 2, self.classSpellsOfInterestMaxCount, 1 do
			slider = self:TemplateSlider_Small("com_mithrandir_smhOverheal" .. i, frame, 100 + i)
			slider:SetPoint("TOPLEFT", oldSlider, "TOPLEFT", 0, -25)
			oldSlider = slider
			if self:ShouldInsertSpell(i) then
				table.insert(self.uiElements, { slider, 8 })
			end
		end

		-- create the confirmation dialog frames
		self:ConfirmationDialog_Template("com_mithrandir_smhAlgorithmAccept", this, function() self:Algorithm_Add() end, SMH_S.ALGORITHM_ADD, SMH_S.ALGORITHM_CANCEL, SMH_S.ALGORITHM_TITLE, SMH_S.ALGORITHM_INSTRUCTIONS, true)
		self:ConfirmationDialog_Template("com_mithrandir_smhResetAccept", this, function() self:Defaults_Update(true); self:Tab_Set(1) end, SMH_S.RESET_CONFIRM, SMH_S.RESET_CANCEL, SMH_S.RESET_TITLE, SMH_S.RESET_INSTRUCTIONS, false)
		self:ConfirmationDialog_Template("com_mithrandir_smhProfileAccept", this, function() self:Profile_New() end, SMH_S.PROFILE_NEW_ADD, SMH_S.PROFILE_NEW_CANCEL, SMH_S.PROFILE_NEW_TITLE, SMH_S.PROFILE_NEW_INSTRUCTIONS, true)
		self:ConfirmationDialog_Template("com_mithrandir_smhProfileDelete", this, function() self:Profile_Delete() end, SMH_S.PROFILE_DELETE_ADD, SMH_S.PROFILE_DELETE_CANCEL, SMH_S.PROFILE_DELETE_TITLE, SMH_S.PROFILE_DELETE_INSTRUCTIONS, false)
		self:ConfirmationDialog_Template("com_mithrandir_smhProfileRename", this, function() self:Profile_Rename() end, SMH_S.PROFILE_RENAME_ADD, SMH_S.PROFILE_RENAME_CANCEL, SMH_S.PROFILE_RENAME_TITLE, SMH_S.PROFILE_RENAME_INSTRUCTIONS, true)

		-- create the tabs for the options panel
		frame = com_mithrandir_smhOptions
		local numberTabs = getn(SMH_S.OPTION_TABS)
		button = self:TemplateButton_Tab(nil, frame, SMH_S.OPTION_TABS[1][1])
		button:SetPoint("CENTER", frame, "BOTTOMLEFT", 79, 61)
		oldButton = button
		for i = 2, numberTabs, 1 do
			button = self:TemplateButton_Tab(nil, frame, SMH_S.OPTION_TABS[i][1])
			button:SetPoint("LEFT", oldButton, "RIGHT", -20, 0)
			oldButton = button
		end
		self.tabs[1] = self:TemplateCheckButton_Tab(nil, frame, 1, SMH_S.OPTION_TABS[1][1], SMH_S.OPTION_TABS[1][2])
		self.tabs[1]:SetPoint("TOPLEFT", frame, "TOPRIGHT", -32, -46)
		self.tabs[1]:SetChecked(1)
		for i = 2, numberTabs, 1 do
			self.tabs[i] = self:TemplateCheckButton_Tab(nil, frame, i, SMH_S.OPTION_TABS[i][1], SMH_S.OPTION_TABS[i][2])
			self.tabs[i]:SetPoint("TOPLEFT", self.tabs[i - 1], "BOTTOMLEFT", 0, -17)
		end
		self:Tab_Set(1)
		self:Frame_Update()

		self:MiniProfile_Create()
		self:Profile_NameUpdate()
		self:MiniProfile_Update()

		self:SpellButtons_Update()

	end

	SMH.Options_OnEvent = function(self)
		if self.eventOptionsDispatch[event] then
			self.eventOptionsDispatch[event](self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
		end
	end

	SMH.Options_OnLoad = function(self)
		if self.classesPermittedToUseAddon[self.class] then
			this:SetScript("OnEvent", function() self:Options_OnEvent() end)
			this:RegisterEvent("VARIABLES_LOADED")
		end
	end

	SMH.Options_ShowHide = function(self)
		if (com_mithrandir_smhOptions:IsVisible()) then com_mithrandir_smhOptions:Hide() else com_mithrandir_smhOptions:Show() end
	end

	SMH.OrderedHealableUnits = function(self)
		local retval = { }
		local priority = { }
		local numberOfPriorities = 11
		local tier
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local unitName

		-- initialize our priority tables to empty
		for i = 1, numberOfPriorities, 1 do
			priority[i] = { }
		end

		local numberInRaid = GetNumRaidMembers()
		local myRaidGroup = 0
		local raid = nil
		local raidPets = nil
		local petUnit
		if numberInRaid > 0 then
			raid = { }
			raidPets = { }
			for i = 1, numberInRaid, 1 do
				local raidName, _, raidGroup = GetRaidRosterInfo(i)
				raid[raidName] = { unit = "raid" .. i, group = raidGroup }
				if raidName == self.name then myRaidGroup = raidGroup end
				petUnit = "raidpet" .. i
				if UnitExists(petUnit) then
					raidPets[UnitName(petUnit)] = { unit = petUnit, group = raidGroup }
				end
			end
		end

		-- The player is always considered to be a healing candidate, irrespective of level.
		tier = self:PriorityForCharacter(self.name, 'player', myRaidGroup, true)
		if tier ~= 0 then
			self:TryToInsertUnitForHealing(priority[tier], 'player', "threshold", nil)
		end

		-- Deal with the rest of the party players
		if currentProfile.healsParty or currentProfile.outOfGroup then
			for i in pairs(self.playerIds) do
				if self:IsHealable(i) then
					unitName = UnitName(i)
					if not currentProfile.healsParty then
						if currentProfile.charactersPriorityHigh[unitName] then tier = 11 else tier = 0 end
					else
						tier = self:PriorityForCharacter(unitName, i, myRaidGroup, true)
					end
					if tier ~= 0 and UnitLevel(i) >= currentProfile.doNotHealBelowLevel then
						self:TryToInsertUnitForHealing(priority[tier], i, "threshold", nil)
					end
				end
			end
		end

		-- Deal with party pets
		if currentProfile.healingPets or currentProfile.outOfGroup then
			for i in pairs(self.petIds) do
				if self:IsHealable(i) then
					unitName = UnitName(i)
					if not currentProfile.healingPets then
						if currentProfile.charactersPriorityHigh[unitName] then tier = 11 else tier = 0 end
					else
						tier = self:PriorityForCharacter(unitName, i, myRaidGroup, true)
					end
					if tier ~= 0 and UnitLevel(i) >= currentProfile.doNotHealBelowLevel then
						self:TryToInsertUnitForHealing(priority[tier], i, "petThreshold", nil)
					end
				end
			end
		end

		-- Deal with the raid players
		if numberInRaid > 0 and (currentProfile.healingRaid or currentProfile.outOfGroup) then
			for name, info in ipairs(raid) do
				if info.group ~= myRaidGroup and self:IsHealable(info.unit) then
					if not currentProfile.healingRaid then
						if currentProfile.charactersPriorityHigh[name] then tier = 11 else tier = 0 end
					else
						tier = self:PriorityForCharacter(name, info.unit, info.group, false)
					end
					if tier ~= 0 and UnitLevel(info.unit) >= currentProfile.doNotHealBelowLevel then
						self:TryToInsertUnitForHealing(priority[tier], info.unit, "threshold", nil)
					end
				end
			end
		end

		-- Deal with raid pets
		if numberInRaid > 0 and (currentProfile.healingRaidPets or currentProfile.outOfGroup) then
			for name, info in ipairs(raidPets) do
				if info.group ~= myRaidGroup and self:IsHealable(info.unit) then
					if not currentProfile.healingRaidPets then
						if currentProfile.charactersPriorityHigh[name] then tier = 11 else tier = 0 end
					else
						tier = self:PriorityForCharacter(name, info.unit, info.group, false)
					end
					if tier ~= 0 and UnitLevel(info.unit) >= currentProfile.doNotHealBelowLevel then
						self:TryToInsertUnitForHealing(priority[tier], info.unit, "petThreshold", nil)
					end
				end
			end
		end

		-- sort each of the priority tables individually to maintain order within priority
		for i = 1, numberOfPriorities, 1 do
			if table.getn(priority[i]) > 0 then
				table.sort(priority[i], function(a, b) return SMH:CompareHealth(a, b) end)
				self:OutputMessage("TIER", "Priority table " .. i .. " has " .. table.getn(priority[i]) .. " healees in it.")
				for j = 1, table.getn(priority[i]), 1 do
					self:OutputMessage("TIER", "Priority " .. i .. " order " .. j .. " is " .. UnitName(priority[i][j].id) .. " " .. self:UnitClass(priority[i][j].id) .. " percent " .. priority[i][j].percent * 100)
				end
			end
		end

		-- and then add them to the overall table
		for i = 1, numberOfPriorities, 1 do
			tableSize = table.getn(priority[i])
			if tableSize > 0 then
				for j = 1, tableSize, 1 do table.insert(retval, j, priority[i][j]) end
			end
		end

		--	The next section of code adds recipients to the front of the priority list (at
		--	progressively higher and higher priority tiers conceptually) based on options
		--	indicating things like whether the target, focus, etc. should be healed.

		--	Put the target's target in the list
		if currentProfile.healsTargetsTarget and self:UnitIsHealable('targettarget') then
			self:DealWithUnsureRecipient(retval, 'targettarget')
		end

		--	Put myself at front of list if my health is less than 40%
		self:TryToInsertUnitForHealing(retval, 'player', "selfThreshold", "Player put at head of heal list")

		--	Put the target at the front of the list if it is healable and damaged
		if currentProfile.targetPriority and self:UnitIsHealable('target') then
			self:DealWithUnsureRecipient(retval, 'target')
		end

		--	Put the focus at the front of the list if it is healable and damaged
		if currentProfile.healsFocus and self:UnitIsHealable('focus') then
			self:DealWithUnsureRecipient(retval, 'focus')
		end

		--	If ALT is used, the player is put at the front of the list
		if (IsAltKeyDown() == 1) then
			self:TryToInsertUnitForHealing(retval, 'player', "threshold", "Player put at front of heal list because of ALT")
		end

		return retval
	end

	-- This routine determines what tier the character belongs in based on the character
	-- priority, class priority, raid group priority and whether the character is in the
	-- player's party.  Higher tier ranking gets better priority.
	--	11	character high
	--	10	class high, classPriorityOverParty
	--	9	class high, partyOverRaid
	--	8	class normal, partyOverRaid
	--	7	class low, partyOverRaid
	--	6	class high
	--	5	raid group high
	--	4	character normal, class normal, raid group normal
	--	3	character low
	--	2	class low
	--	1	raid group low
	--	0	character ignored, class ignored, raid group ignored
	SMH.PriorityForCharacter = function(self, characterName, unitName, raidGroup, isInParty)
		local retval = 4
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if currentProfile.charactersPriorityHigh[characterName] then retval = 11
		elseif currentProfile.characterPriorityLow[characterName] then retval = 3
		elseif currentProfile.characterPriorityIgnored[characterName] then retval = 0
		else  -- character normal, proceed to class
			local unitClass = self:UnitClass(unitName)
			local classPriority = currentProfile.classPriorities[unitClass]
			if classPriority == 3 then
				if currentProfile.classPriorityOverParty then retval = 10
				elseif currentProfile.partyOverRaid and isInParty then retval = 9
				else retval = 6
				end
			elseif classPriority == 1 then
				if currentProfile.partyOverRaid and isInParty then retval = 7
				else retval = 2
				end
			elseif classPriority == 0 then retval = 0
			else	-- class normal, proceed to raid group
				if currentProfile.partyOverRaid and isInParty then retval = 8
				elseif raidGroup > 0 then
					local raidPriority = currentProfile.raidPriorities[raidGroup]
					if raidPriority == 3 then retval = 5
					elseif raidPriority == 2 then retval = 4
					elseif raidPriority == 1 then retval = 1
					else retval = 0
					end
				end
			end
		end
		return retval
	end

	SMH.Profile_CreateNewFromCurrent = function(self, newProfileName)
		SMH_Configuration.profiles[newProfileName] = self:CopyTable(SMH_Configuration.profiles[SMH_Configuration.currentProfile])
	end

	SMH.Profile_Delete = function(self)
		local existing, count = self:Profile_Named(string.lower(SMH_Configuration.currentProfile))

		if existing and count > 1 then
			SMH_Configuration.profiles[SMH_Configuration.currentProfile] = nil
			self:Profile_SetName(self:Profile_First())
			self:ProfileButtons_Show()
			self:MiniProfile_Update()
		end
	end

	SMH.Profile_First = function(self)
		local retval = nil

		for n in pairs(SMH_Configuration.profiles) do
			if retval == nil then retval = n end
		end
		return retval
	end

	SMH.Profile_Named = function(self, aLowercaseName)
		local retval = nil
		local count = 0

		for n in pairs(SMH_Configuration.profiles) do
			if (string.lower(n) == aLowercaseName) then
				retval = SMH_Configuration.profiles[n]
			end
			count = count + 1
		end
		return retval, count
	end

	SMH.Profile_NameUpdate = function(self)
		self.stringCurrentProfile:SetText(string.format(SMH_S.PROFILE_TEXT_FORMAT, SMH_Configuration.currentProfile))
	end

	SMH.Profile_New = function(self)
		local newProfileName = com_mithrandir_smhProfileAcceptField:GetText()

		if newProfileName ~= '' then
			local existing, count = self:Profile_Named(string.lower(newProfileName))
			if existing == nil and count < self.maxNumberInProColumn then
				self:Profile_CreateNewFromCurrent(newProfileName)
				self:Profile_SetName(newProfileName)
				self:ProfileButtons_Show()
				self:MiniProfile_Update()
			end
		end
	end

	SMH.Profile_Rename = function(self)
		local newProfileName = com_mithrandir_smhProfileRenameField:GetText()

		if newProfileName ~= '' then
			local existing, count = self:Profile_Named(string.lower(newProfileName))
			if existing == nil then
				self:Profile_CreateNewFromCurrent(newProfileName)
				SMH_Configuration.profiles[SMH_Configuration.currentProfile] = nil
				self:Profile_SetName(newProfileName)
				self:ProfileButtons_Show()
				self:MiniProfile_Update()
			end
		end
	end

	SMH.Profile_Set = function(self)
		self:Profile_SetName(this:GetText())
		self:MiniProfile_Update()
	end

	SMH.Profile_SetName = function(self, profileName)
		SMH_Configuration.currentProfile = profileName
		self:Profile_NameUpdate()
		self:MiniMapButton_UpdatePosition()
	end

	SMH.ProfileButtons_Hide = function(self)
		for i = 1, self.maxNumberInProColumn, 1 do
			self.buttonsProfile[i]:Hide()
			self.buttonsProfileAppears[i]:Hide()
		end
	end

	SMH.ProfileButtons_Show = function(self)
		local temp = { }

		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			self.buttonsProfile[i]:SetText(n)
			self.buttonsProfile[i]:Show()
			self.buttonsProfileAppears[i]:Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInProColumn, 1 do
			self.buttonsProfile[i]:Hide()
			self.buttonsProfileAppears[i]:Hide()
		end
	end

	SMH.ProfileCheck_OnClick = function(self)
		local profileName = self:LookupOrderedProfileName(this:GetID())
		SMH_Configuration.profiles[profileName]["shouldDisplayProfile"] = (this:GetChecked() == 1)
		self:MiniProfile_Update()
	end

	SMH.ProfileCheck_OnLoad = function(self)
		getglobal(this:GetName().."Text"):SetText(SMH_S.PROFILE_CHECKBUTTON_TITLE)
	end

	SMH.ProfileCheck_OnShow = function(self)
		local profileName = self:LookupOrderedProfileName(this:GetID())
		if SMH_Configuration.profiles[profileName]["shouldDisplayProfile"] then
			this:SetChecked(1)
		else
			this:SetChecked(0)
		end
	end

	SMH.ShouldInsertSpell = function(self, position)
		local retval = false

		if position <= table.getn(self.classSpellsOfInterest[self.class]) then retval = true end
		return retval
	end

	SMH.Slider_OnShow = function(self)
		local id = this:GetID()
		local name = this:GetName()
		local profile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local normalId = id
		while (normalId > 100) do normalId = normalId - 100 end
		local spellName = nil
		if id > 100 and id < 500 then
			spellName = self.classSpellsOfInterest[self.class][normalId]
		end

		getglobal(name .. "High"):SetText()
		getglobal(name .. "Low"):SetText()
		self:Slider_SetTitle(this)
		this:SetValueStep(1)

		if id < 100 then
			local min = 1
			local max = 100
			if id == 5 then min = 0; max = 359
			elseif id == 6 then max = 70
			elseif id == 7 then min = 0
			end
			this:SetMinMaxValues(min, max)
			this:SetValue(profile[SMH_S.SLIDER_TITLE_FORMATS[id][1]])
		elseif id > 100 and id < 200 then
			this:SetMinMaxValues(0, table.getn(self.levelLearned[spellName]) - 1)
			this:SetValue(profile.overhealRanks[spellName])
		elseif id > 200 and id < 300 then
			this:SetMinMaxValues(1, table.getn(self.levelLearned[spellName]))
			this:SetValue(profile.maxHealRanks[spellName])
		elseif id > 300 and id < 400 then
			this:SetMinMaxValues(1, table.getn(self.levelLearned[spellName]))
			this:SetValue(profile.minHealRanks[spellName])
		elseif id > 400 and id < 500 then
			this:SetMinMaxValues(1, table.getn(self.levelLearned[spellName]))
			this:SetValue(profile.minRaiseHealRanks[spellName])
		elseif id > 500 and id < 600 then
			this:SetMinMaxValues(0, 3)
			this:SetValue(profile.classPriorities[self.allClasses[normalId]])
		elseif id > 600 and id < 700 then
			local max = 3
			if normalId == 1 then max = 4 elseif normalId == 4 or normalId == 5 then max = 2 end
			this:SetMinMaxValues(0, max)
			this:SetValue(profile.messagePlaces[self.messageTypes[normalId]])
		elseif id > 700 and id < 800 then
			this:SetMinMaxValues(50, 150)
			this:SetValue(profile.classHealPercents[self.allClasses[normalId]])
		elseif id > 800 and id < 900 then
			this:SetMinMaxValues(0, 3)
			this:SetValue(profile.raidPriorities[normalId])
		end

	end

	SMH.Slider_OnValueChanged = function(self)
		local id = this:GetID()
		local profile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local value = this:GetValue()
		local normalId = id
		while (normalId > 100) do normalId = normalId - 100 end
		local spellName = nil
		if id > 100 and id < 500 then
			spellName = self.classSpellsOfInterest[self.class][normalId]
		end

		if id < 100 then
			profile[SMH_S.SLIDER_TITLE_FORMATS[id][1]] = value
			if id == 5 then self:MiniMapButton_UpdatePosition() end
		elseif id > 100 and id < 200 then
			profile.overhealRanks[spellName] = value
		elseif id > 200 and id < 300 then
			profile.maxHealRanks[spellName] = value
		elseif id > 300 and id < 400 then
			profile.minHealRanks[spellName] = value
		elseif id > 400 and id < 500 then
			profile.minRaiseHealRanks[spellName] = value
		elseif id > 500 and id < 600 then
			profile.classPriorities[self.allClasses[normalId]] = value
		elseif id > 600 and id < 700 then
			profile.messagePlaces[self.messageTypes[normalId]] = value
		elseif id > 700 and id < 800 then
			profile.classHealPercents[self.allClasses[normalId]] = value
		elseif id > 800 and id < 900 then
			profile.raidPriorities[normalId] = value
		end

		self:Slider_SetTitle(this)
	end

	SMH.Slider_SetTitle = function(self, this)
		local id = this:GetID()
		local name = this:GetName()
		local profile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local normalId = id
		while (normalId > 100) do normalId = normalId - 100 end
		local spellName = nil
		if id > 100 and id < 500 then
			spellName = self.classSpellsOfInterest[self.class][normalId]
		end
		local theTitle = getglobal(name .. "Text")

		local outputString
		if id < 100 then
			local format = SMH_S.SLIDER_TITLE_FORMATS[id][2]
			outputString = string.format(format, profile[SMH_S.SLIDER_TITLE_FORMATS[id][1]])
		elseif id > 100 and id < 200 and spellName then
			outputString = string.format("%s: %s", spellName, profile.overhealRanks[spellName])
		elseif id > 200 and id < 300 and spellName then
			outputString = string.format("%s: %s", spellName, profile.maxHealRanks[spellName])
		elseif id > 300 and id < 400 and spellName then
			outputString = string.format("%s: %s", spellName, profile.minHealRanks[spellName])
		elseif id > 400 and id < 500 and spellName then
			outputString = string.format("%s: %s", spellName, profile.minRaiseHealRanks[spellName])
		elseif id > 500 and id < 600 then
			local className = self.allClasses[normalId]
			outputString = string.format("%s: %s", className, self.priorityLabels[profile.classPriorities[className] + 1])
		elseif id > 600 and id < 700 then
			local titleName = self.messageTitles[normalId]
			outputString = string.format("%s: %s", titleName, self.messageLabels[profile.messagePlaces[self.messageTypes[normalId]] + 1])
		elseif id > 700 and id < 800 then
			local className = self.allClasses[normalId]
			outputString = string.format("%s: %d%%", className, profile.classHealPercents[className])
		elseif id > 800 and id < 900 then
			outputString = string.format("%d: %s", normalId, self.priorityLabels[profile.raidPriorities[normalId] + 1])
		end
		if outputString then theTitle:SetText(outputString) end
	end

	SMH.SpellButtons_Update = function(self)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		for i = 1, table.getn(currentProfile.defaultSpells), 1 do
			self.buttonsAlgorithmControl[i].tooltiptext = currentProfile.defaultSpells[i][1]
			self.buttonsAlgorithmControl[i]:SetNormalTexture(self.defaultSpellIcons[currentProfile.defaultSpells[i][1]])
			self.buttonsAlgorithmCast[i]:SetChecked(currentProfile.defaultSpells[i][2])
		end
	end

	SMH.SwapDefaultSpells = function(self, left, right)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local temp = currentProfile.defaultSpells[left]
		currentProfile.defaultSpells[left] = currentProfile.defaultSpells[right]
		currentProfile.defaultSpells[right] = temp
		self:SpellButtons_Update()
	end

	SMH.Tab_OnClick = function(self, tabId)
		if not tabId then tabId = this:GetID() end
		self:Tab_Set(tabId)
		local numberTabs = getn(SMH_S.OPTION_TABS)
		for i = 1, numberTabs, 1 do
			if (i ~= tabId) then
				self.tabs[i]:SetChecked(nil)
			else
				self.tabs[i]:SetChecked(1)
			end
		end
		self:Frame_Update()
	end

	SMH.Tab_Set = function(self, tabId)
		local reshowing = false
		if tabId == self.currentTab then reshowing = true end
		self.currentTab = tabId

		if (tabId == 3) then
			self:AlgorithmButtons_Show()
			self:SpellButtons_Update()
		else
			self:AlgorithmButtons_Hide()
		end
		if (tabId == 4) then
			self:CharacterPriorityButtons_Show()
		else
			self:CharacterPriorityButtons_Hide()
		end
		if (tabId == 7) then
			self:ProfileButtons_Show()
		else
			self:ProfileButtons_Hide()
		end

		local numberUIElements = getn(self.uiElements)
		for i = 1, numberUIElements, 1 do
			if tabId == self.uiElements[i][2] then
				if reshowing then self.uiElements[i][1]:Hide() end
				self.uiElements[i][1]:Show()
			else
				self.uiElements[i][1]:Hide()
			end
		end
	end

	SMH.TemplateButton = function(self, name, parent)
		local frame = CreateFrame("Button", name, parent, "GameMenuButtonTemplate")
		frame:SetWidth(170); frame:SetHeight(17); frame:Hide()
		return frame
	end

	SMH.TemplateButton_Algorithm = function(self, name, parent)
		local frame = self:TemplateButton(name, parent)
		frame:SetScript("OnClick", function() self:Algorithm_Remove() end)
		return frame
	end

	SMH.TemplateButton_AlgCtl = function(self, name, parent)
		local frame = self:TemplateButton_Default(name, parent)
		frame:SetScript("OnClick", function() self:Algorithm_Control() end)
		return frame
	end

	SMH.TemplateButton_CharacterPriority = function(self, name, parent, id)
		local frame = CreateFrame("Button", name, parent, "GameMenuButtonTemplate")
		frame:SetWidth(70); frame:SetHeight(17); frame:Hide(); frame:SetID(id)
		frame:SetScript("OnClick", function() self:CharacterPriority_Add() end)
		return frame
	end

	SMH.TemplateButton_CharPri = function(self, name, parent)
		local frame = CreateFrame("Button", name, parent, "GameMenuButtonTemplate")
		frame:SetWidth(70); frame:SetHeight(17); frame:Hide()
		frame:SetScript("OnClick", function() self:CharacterPriority_Remove() end)
		return frame
	end

	SMH.TemplateButton_Default = function(self, name, parent)
		local frame = CreateFrame("Button", name, parent)
		frame:SetWidth(40); frame:SetHeight(40); frame:Hide()
		frame:SetScript("OnEnter", function() GameTooltip:SetOwner(this, "ANCHOR_RIGHT"); GameTooltip:SetText(this.tooltiptext) end)
		frame:SetScript("OnLeave", function() GameTooltip:Hide() end)
		return frame
	end

	SMH.TemplateButton_DefaultLeft = function(self, name, parent)
		local frame = CreateFrame("Button", name, parent)
		frame:SetWidth(32); frame:SetHeight(32); frame:Hide()
		frame:SetNormalTexture("Interface/ChatFrame/UI-ChatIcon-ScrollUp-Up")
		frame:SetPushedTexture("Interface/ChatFrame/UI-ChatIcon-ScrollUp-Down")
		frame:SetHighlightTexture("Interface/Buttons/UI-Common-MouseHilight")
		return frame
	end

	SMH.TemplateButton_Profile = function(self, name, parent, id)
		local frame = CreateFrame("Button", name, parent, "GameMenuButtonTemplate")
		frame:SetWidth(170)
		frame:SetHeight(17)
		if id == -1 then
			frame:SetScript("OnClick", function() self:Profile_Set() end)
		else
			frame:SetScript("OnClick", function() self:MiniProfile_Set() end)
			frame:SetID(id)
		end
		frame:Hide()
		return frame
	end

	SMH.TemplateButton_Tab = function(self, name, parent, tooltiptext)
		local frame = CreateFrame("Button", name, parent)
		frame:SetWidth(128); frame:SetHeight(64); frame:Hide()
		frame:SetHitRectInsets(15, 14, 13, 15)
		frame:SetScript("OnClick", function() self:Tab_Set(this:GetID()) end)
		frame:SetScript("OnEnter", function() GameTooltip:SetOwner(this, "ANCHOR_RIGHT"); GameTooltip:SetText(tooltiptext, 1.0, 1.0, 1.0) end)
		frame:SetScript("OnLeave", function() GameTooltip:Hide() end)
		frame:SetNormalTexture("Interface/SpellBook/UI-SpellBook-Tab-Unselected")
		frame:SetHighlightTexture("Interface/SpellBook/UI-SpellBookPanel-Tab-Highlight")
		return frame
	end

	SMH.TemplateCheckButton = function(self, name, parent, id)
		local frame = CreateFrame("CheckButton", name, parent, "OptionsCheckButtonTemplate")
		frame:Hide(); frame:SetID(id)
		frame:SetHitRectInsets(8, 8, 8, 8)
		frame:SetScript("OnClick", function() self:CheckButton_OnClick() end)
		frame:SetScript("OnShow", function() self:CheckButton_OnShow() end)
		getglobal(name .. "Text"):SetText(SMH_S.CHECK_BUTTON_TITLES[id][2])
		return frame
	end

	SMH.TemplateCheckButton_Appear = function(self, name, parent, id)
		local frame = CreateFrame("CheckButton", name, parent, "OptionsCheckButtonTemplate")
		frame:SetWidth(16); frame:SetHeight(16); frame:Hide(); frame:SetID(id)
		frame:SetScript("OnClick", function() self:ProfileCheck_OnClick() end)
		frame:SetScript("OnShow", function() self:ProfileCheck_OnShow() end)
		getglobal(name .. "Text"):SetText(SMH_S.PROFILE_CHECKBUTTON_TITLE)
		return frame
	end

	SMH.TemplateCheckButton_Mini = function(self, name, parent, id)
		local frame = CreateFrame("CheckButton", name, parent, "OptionsCheckButtonTemplate")
		frame:SetWidth(16); frame:SetHeight(16); frame:Hide(); frame:SetID(id)
		frame:SetHitRectInsets(2, 2, 2, 2)
		frame:SetScript("OnClick", function() self:MiniCheckButton_OnClick() end)
		frame:SetScript("OnShow", function() self:MiniCheckButton_OnShow() end)
		return frame
	end

	SMH.TemplateCheckButton_Tab = function(self, name, parent, id, tooltiptext, textureName)
		local frame = CreateFrame("CheckButton", name, parent)
		frame:SetWidth(32); frame:SetHeight(32); frame:Hide()
		frame:SetID(id)
		local texture = frame:CreateTexture(nil, "BACKGROUND")
		texture:SetTexture("Interface/SpellBook/SpellBook-SkillLineTab")
		texture:SetWidth(64); texture:SetHeight(64)
		texture:SetPoint("TOPLEFT", -3, 11)
		frame:SetScript("OnClick", function() self:Tab_OnClick() end)
		frame:SetScript("OnEnter", function() GameTooltip:SetOwner(this, "ANCHOR_RIGHT"); GameTooltip:SetText(tooltiptext) end)
		frame:SetScript("OnLeave", function() GameTooltip:Hide() end)
		frame:SetNormalTexture(textureName)
		frame:SetHighlightTexture("Interface/Buttons/ButtonHilight-Square")
		frame:SetCheckedTexture("Interface/Buttons/CheckButtonHilight")
		return frame
	end

	SMH.TemplateSlider_Large = function(self, name, parent, id)
		local frame = self:TemplateSlider_Small(name, parent, id)
		frame:SetWidth(290)
		return frame
	end

	SMH.TemplateSlider_Small = function(self, name, parent, id)
		local frame = CreateFrame("Slider", name, parent, "OptionsSliderTemplate")
		frame:SetWidth(130); frame:SetHeight(17); frame:Hide(); frame:SetID(id)
		frame:SetScript("OnValueChanged", function() self:Slider_OnValueChanged() end)
		frame:SetScript("OnShow", function() self:Slider_OnShow() end)
		return frame
	end

	SMH.TryToInsertUnitForHealing = function(self, tableName, unitName, parameterName, debugMessage)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local characterName = UnitName(unitName)
		self:ProcessOtherHeals()
		local possibleHealingForUnit = self.currentOtherHealsByCharacter[characterName]
		if possibleHealingForUnit == nil then possibleHealingForUnit = 0 end
		local currentHealth = UnitHealth(unitName) + possibleHealingForUnit * (currentProfile.otherHealerConfidence / 100)
		local maxHealth = UnitHealthMax(unitName)
		local percentHealth = currentHealth / maxHealth
		-- Only put damaged units that meet the damage threshold into the table.
		if (currentHealth < maxHealth and percentHealth < (currentProfile[parameterName] / 100.0)) then
			table.insert(tableName, 1, { id = unitName, percent = percentHealth, current = currentHealth, max = maxHealth })
			if (debugMessage ~= nil) then self:OutputMessage("DEBUG", debugMessage) end
		end
	end

	--	This routine ensures that druids in different forms are
	--	considered the class that the preferences indicate.
	SMH.UnitClass = function(self, unitId)
		local retval = UnitClass(unitId)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if retval == SMH_S.DRUID and (currentProfile.druidCatsAsRogues or currentProfile.druidBearsAsWarriors) then
			local type = UnitPowerType(unitId)
			if type == 1 and currentProfile.druidBearsAsWarriors then
				retval = SMH_S.WARRIOR
			elseif type == 3 and currentProfile.druidCatsAsRogues then
				retval = SMH_S.ROGUE
			end
		end
		return retval
	end

	SMH.UnitIsHealable = function(self, unit)
		if not UnitExists(unit) then return false end
		if not UnitIsFriend('player', unit) then return false end
		if     UnitIsEnemy(unit, 'player') then return false end
		if     UnitCanAttack(unit, 'player') then return false end
		if     UnitCanAttack('player', unit) then return false end
		if     unit ~= 'player' and not UnitCanCooperate('player', unit) then return false end
		if not UnitIsConnected(unit) then return false end
		if     UnitIsDead(unit) then return false end
		if     UnitIsGhost(unit) then return false end
		return true
	end

	SMH.UpdateTotalPlusHealingText = function(self)
		local outputString = nil
		local outputColor = self.colorGreen
		if self.hasBrokenPlusHealingItems then outputColor = self.colorRed end

		outputString = string.format(SMH_S.TOTAL_EXTRA_HEALING_FORMAT, outputColor, self.extraHealingAmount, self.colorStop)
		if nil ~= self.talentRank[SMH_S.SPIRITUAL_GUIDANCE] and self.talentRank[SMH_S.SPIRITUAL_GUIDANCE] > 0 then
			outputString = outputString .. string.format(SMH_S.SG_HEALING_FORMAT, self.modification[SMH_S.SPIRITUAL_GUIDANCE])
		end
		if nil ~= self.talentRank[SMH_S.NATURES_BLESSING] and self.talentRank[SMH_S.NATURES_BLESSING] > 0 then
			outputString = outputString .. string.format(SMH_S.NB_HEALING_FORMAT, self.modification[SMH_S.NATURES_BLESSING])
		end
		if nil ~= self.talentRank[SMH_S.HOLY_GUIDANCE] and self.talentRank[SMH_S.HOLY_GUIDANCE] > 0 then
			outputString = outputString .. string.format(SMH_S.HG_HEALING_FORMAT, self.modification[SMH_S.HOLY_GUIDANCE])
		end
		if nil ~= self.talentRank[SMH_S.LUNAR_GUIDANCE] and self.talentRank[SMH_S.LUNAR_GUIDANCE] > 0 then
			outputString = outputString .. string.format(SMH_S.LG_HEALING_FORMAT, self.modification[SMH_S.LUNAR_GUIDANCE])
		end
		if nil ~= self.talentRank[SMH_S.NURTURING_INSTINCT] and self.talentRank[SMH_S.NURTURING_INSTINCT] > 0 then
			outputString = outputString .. string.format(SMH_S.NI_HEALING_FORMAT, self.modification[SMH_S.NURTURING_INSTINCT])
		end
		outputString = outputString .. string.format(SMH_S.BUFF_HEALING_FORMAT, self.plusHealingFromBuffs)

		self.stringCurrentHealing:SetText(outputString)
	end

	SMH.WhichPriorityLevel = function(self, classModifier, isParty)
		local retval = classModifier + 1
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if isParty then
			if classModifier == 3 then
				if currentProfile.classPriorityOverParty then
					retval = 7
				elseif currentProfile.partyOverRaid then
					retval = 6
				else
					retval = 5
				end
			elseif classModifier == 2 then
				if currentProfile.partyOverRaid then
					retval = 6
				end
			end
		else
			if classModifier == 3 then
				if currentProfile.classPriorityOverParty then retval = 7 else retval = 5 end
			end
		end
		return retval
	end

end
